/************************************************************************/
/*                                                                      */
/*  NAME : SC61860 DISASSEMBLER SOURCE CODE                             */
/*  FILE : DSC61860.c                                                   */
/*  Copyright (c)  'BLUE' 2006-2024                                 */
/*                                                                      */
/*  REVISION HISTORY:                                                   */
/*  Rev : 0.01  2006.10.13  JJn                                    */
/*  Rev : 0.02  2006.10.16  CASE1/CASE2ΉBBMPo͂SC`ɏCB  */
/*                          Rgo͂ǁB                        */
/*  Rev : 0.03  2006.11.07  R[h`FbN𒲐BCASE2ߏCB   */
/*                          vZ̃oOC                        */
/*  Rev : 0.04  2006.12.24  ʕsȃt@C*.binʂƂB     */
/*  Rev : 0.05  2009.11.10  IYS/IXSRgo͂(By YANAGIDA)      */
/*  Rev : 0.06  2021.07.11  unsigned long -> unsigned int ɕύX        */
/*                          unsigned int-> unsigned int ɕύX          */
/*                          PBFo(]vȃJ}oꍇ)C       */
/*                          EOFo͂FORDOSL̂ݎ{Ƃ         */
/*  Rev : 0.07  2021.08.25  CASE1/CASE2o͌`SC61ɍ킹B       */
/*  Rev : 0.08  2022.05.01  SA^߂T|[gBRgo͋@\*/
/*                          Intel HEXo(/hex)w莞ChecksumCB */
/*                          /img SABẅBitmapo        */
/*  Rev : 0.09  2023.05.13  SASw莞Ƀ_vf[^o͂錏̏C */
/*              2023.06.18  #include^߂ɑΉ                      */
/*                          ʓo^`FbNC                      */
/*                          /ACwǉB                             */
/*                          "AhX+R[h+" Rgŏo͂ */
/*                          Symbol.h:x`G[[jOƂ */
/*                          l̃x`Ƀ[jO\  */
/*  Rev : 0.10  2023.08.26  SAWw莞̃GfBȀC               */
/*              2024.01.12  /aco͂C                               */
/*                          LP/LIDP߂̃xSAwDƂ   */
/*                                                                      */
/************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<fcntl.h>
#include"DSC61860.h"
/*------------------------------------------------------------------*/
/*  萔`                                                        */
/*------------------------------------------------------------------*/
#define FORDOS  	0				/* 1:DOSpɃRpC      */
#if FORDOS
char	TmpName[] ="_dsc61_.tmp";	/* e|t@C(DOSp)  */
char	name[]	="SC61860 DISASSEMBLER FOR DOS ";/* (DOSp)     */
#else
char	name[]	="SC61860 DISASSEMBLER "		;/* (Win32)     */
#endif
char	rev[]	="Rev 0.10";				/* Revision             */
/* /NCIvV̈ꎞo͐ */
char	NcTmp[] ="_dsc61nc.tmp";	/* e|t@C(/NCp)  */
/* p\ */
char	LabelStr[]	= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789@_";
char	DecStr[]	= "0123456789";
char	HexStr[]	= "0123456789ABCDEFabcdef";
/*------------------------------------------------------------------*/
/*  ϐ`                                                        */
/*------------------------------------------------------------------*/
char	SrcFile[MAXLINE];			/* \[Xt@C             */
char	LstFile[MAXLINE];			/* Xgt@C             */
char	ExeFile[MAXLINE];			/* st@C               */
char	IncFile[MAXLINE];			/* CN[ht@C       */
FILE	*IncFD[MAXINC];				/* INCLUDEt@CfBXNv^*/
FILE	*SymbolFD;					/* Symbolt@CfBXNv^ */
FILE	*SrcFD;						/* \[Xt@CfBXNv^ */
FILE	*LstFD;						/* Xgt@CfBXNv^ */
#if FORDOS
FILE	*TmpFD;						/* TEMPt@CfBXNv^   */
#endif
unsigned short	IncLevel;			/* INCLUDEx(x1܂ŉ) */
unsigned int	AdrSet;				/* AhXwv         */
unsigned int	Adrs[4];			/* AhXi[GA           */
unsigned int	Ftype;				/* َ̧(0:pbf1:bas2:hex)  */
unsigned int	pass;				/* AZupX(0A1)       */
unsigned int	pr;					/* ʏo̓tO               */
unsigned int	Tab;				/* TABo̓tO                */
unsigned int	Comment;			/* Rgo(1:A0:Ȃ) */
unsigned int 	DbOut;				/* DB`o(1:v)       */
unsigned int 	PbfOut;				/* PBFo(1:v)          */
unsigned int 	BasOut;				/* BASo(1:v)          */
unsigned int 	HexOut;				/* Intel HEX(8bit)o(1:v) */
unsigned int 	PjOut;				/* PJ HEXo(1:v)       */
unsigned int 	BmpOut;				/* BMPo(1:v)          */
unsigned int 	OutputImg;			/* Imageo(1:v)        */
unsigned int 	BmpMono;			/* BMPmNo(1:v)  */
unsigned int	BmpStart;			/* BMPo͊JnAhX          */
unsigned int 	BinOut;				/* oCio(1:v)     */
unsigned int 	LblEnt;				/* xo^v               */
unsigned int 	DataFlag;			/* f[^͗vtO         */
unsigned int	BuffSize;			/* o̓obt@TCY           */
unsigned int 	StartFlag;			/* sJnAhXw(1:) */
unsigned int 	NoCode;				/* R[ho͋֎~tO(1:֎~) */
unsigned int 	StartAdr;			/* tAZuJnAhX     */
unsigned int 	EndAdr;				/* tAZuIAhX     */
unsigned int 	ExecAdr;			/* sJnAhX             */
unsigned int 	AsmAdr;				/* AZuAhX           */
unsigned int 	LblAdr;				/* JR/JP/CAL擪AhX        */
unsigned int	WordAdr;			/* 0ȊO:WORDAhbVOw */
unsigned int	LabelCnt;			/* xo^                 */
LBL				* LabelTbl;			/* xo^e[u|C^   */
#if _Support_SA
unsigned int	AreaCnt;			/* SÄo^                 */
unsigned int	AreaFlag;			/* SÄ撆tO(1:ON)         */
SATBL			* AreaTbl;			/* SÄo^e[u|C^   */
#endif /* _Support_SA */
struct	outtbl	OutTbl;				/* \͌ʃe[u         */
unsigned int	OutCnt;				/* o̓oCg                 */
unsigned char*	OutBuf;				/* ߏo̓obt@|C^     */
unsigned char	ImgTbl[1536];		/* rbgC[We[u(192*64)*/
char 			oprwk[MAXLINE+2];	/* jjbN/Iyhp[N*/
                                    /* rpɒӂ邱     */

char			calcwk[MAXLINE+2];	/* xZobt@           */
int				CalcPtr;			/* Zobt@|C^         */
unsigned int	Ckind;				/* Z̖̉tO       */
int				IfLevel;			/* #if`#endif x           */
unsigned char	AsmFlag;			/* AZu֎~/          */
unsigned char	IfStk[IFLEVEL];		/* AZu֎~/X^bN  */
unsigned char	OpCase_K;			/* CASEpKWX^ݒl        */
unsigned char	OpCase2Count;		/* CASE2pJE^              */

/*------------------------------------------------------------------*/
/*  vg^Cv錾                                                */
/*------------------------------------------------------------------*/
int main(int argc, char *argv[]);
void ClrOpt( void );
int DisAsmProcess( char * );
int InitDisAsm( char * File );
int ReadPbf( void );
int ReadBas( void );
int ReadHex( void );
int ReadBin( void );
int ReadTxt( void );
int ReadBmp( void );
int ReadIhx( void );
void ClearFlag( void );
int DisAsmCode( void );
void SetAddressLabel( int opr, unsigned int flag, unsigned int adr );
int ChgCode( char * dst , char * src );
int GetLine( FILE *fd ,char *buff );
int GetLine2( FILE *fd ,char *buff );
int GetParam( char *buff );
int ReadSymbol( void );
int SetLabel( char * buff , unsigned int adr );
int SetLabelEntry( OUTTBL * Tbl , unsigned int adr );
int GetLabel( char * buff , unsigned int adr );
int GetLabelAdr( char * buff , unsigned int * adr );
int GetLabelCmt( char * buff , char * comment );
int CheckLabel( char * buff );
int GetMacKind( char * buff );
int GetCalcData( char * buff , unsigned int * kind ,unsigned int * adr );
int CalcVal(unsigned int * value );
int CalcVal0(unsigned int * value );
int CalcValShift(unsigned int * value );
int CalcVal1(unsigned int * value );
int CalcVal2(unsigned int * value );
int CalcVal3( unsigned int *value );
int GetValue(unsigned int *value );
int GetData( char *buff , unsigned int * data );
int ImageDump( unsigned int start , unsigned int max_size , unsigned int div );
void PrintData( unsigned int start , unsigned int end );
void PrintList( void );
#if _Support_SA
int SetAreaTbl( unsigned char type , unsigned int adr , unsigned int size , unsigned int div );
int GetArea( unsigned int adr ,SATBL *Tbl);
int GetAreaName( char * buff , unsigned int adr );
int SetLabelTbl( unsigned int flag , unsigned int adr );
void PrintArea( unsigned int start , unsigned int end );
#endif /* _Support_SA */

/**********************************************************************/
/*   main    : main routine                                           */
/*                                                                    */
/*       : C                                             */
/*       : R}hCIvV                               */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int main(int argc, char *argv[])
{
	int	rc,i;

	/* No[W̕\ */
	printf( "%s%s\n",name,rev );

	/* R}hC̃`FbN */
	if( argc > 9 ){
		printf("Invalid Parameters.\n");
		exit(1);
	}
	if ( !argv[1] ){
		printf("Invalid Source File Name.\n");
		exit (1);
	}
	/* ̓t@C̍쐬 */
	sprintf( SrcFile , "%s" , argv[1] );
	/* IvV */
	pr = 0;

	/* rIvV */
	ClrOpt();

	/* IvV */
	pr = 0;
	Tab = 1;
	StartFlag = 0;
	DataFlag = 0;
	NoCode = 0;
	BmpStart = 0;
	AdrSet = 0;
	WordAdr = 0;
	Comment = 0;
	OutputImg = 0;

	i=2;
	while( argv[i] ){
		/* Intel HEX(8bit)`ŏo͂ */
		if (!strcmp("/hex",argv[i])||!strcmp("/HEX",argv[i])){ ClrOpt(); HexOut = 1; i++; continue; }
		/* PJ HEX`ŏo͂ */
		if (!strcmp("/pj",argv[i])||!strcmp("/PJ",argv[i])){ ClrOpt(); PjOut = 1; i++; continue; }
		/* DB`ŏo͂ */
		if (!strcmp("/db",argv[i])||!strcmp("/DB",argv[i])){ ClrOpt(); DbOut = 1; i++; continue; }
		/* BASt@Co͂ */
		if (!strcmp("/bas",argv[i])||!strcmp("/BAS",argv[i])){ ClrOpt(); BasOut = 1; i++; continue; }
		/* PBFt@Co͂ */
		if (!strcmp("/p",argv[i])||!strcmp("/P",argv[i])){ ClrOpt(); PbfOut = 1; i++; continue; }
		/* oCio͂ */
		if (!strcmp("/b",argv[i])||!strcmp("/B",argv[i])){ ClrOpt(); BinOut = 1; i++; continue; }
		/* rbg}bvimNjo͂ */
		if (!strcmp("/mono",argv[i])||!strcmp("/MONO",argv[i])){ ClrOpt(); BmpMono = 1; goto bmp_opt; }
		/* rbg}bvo͂ */
		if (!strcmp("/bmp",argv[i])||!strcmp("/BMP",argv[i])){
			ClrOpt();
bmp_opt:
			BmpOut = 1;
			i++;
			/* p[^ */
			if( argv[i] ){
				/* R}hCo */
				sprintf( oprwk , "%s" , argv[i] );
				/* 16i\L0x&HɏC */
				if( !memcmp(oprwk,"0x",2)||!memcmp(oprwk,"0X",2) ){
					oprwk[0]='$';
					oprwk[1]='0';
				}
				/* f[^肾 */
				if (GetData( oprwk , &BmpStart )){
					/* f[^ł͂ȂꍇAp[^o */
					BmpStart = 0;
					continue;
				}
				i++;
			}
			continue;
		}
		/* 擪AhX/sAhX擾 */
		if (!strcmp("/adr",argv[i])||!strcmp("/ADR",argv[i])){
			i++;
			/* p[^ */
			while( argv[i] ){
				/* R}hCo */
				sprintf( oprwk , "%s" , argv[i] );
				/* 16i\L0x&HɏC */
				if( !memcmp(oprwk,"0x",2)||!memcmp(oprwk,"0X",2) ){
					oprwk[0]='$';
					oprwk[1]='0';
				}
				/* AhX擾 */
				if (GetData( oprwk , &Adrs[AdrSet] )){
					/* ̃IvVʂł */
					break;
				}
				AdrSet++;
				i++;
			}
			continue;
		}
		/* lstt@Co͎ɃR[hOFFɂ */
		if (!strcmp("/nc",argv[i])||!strcmp("/NC",argv[i])){ NoCode = 1; i++; continue; }
		/* lstt@Co͎ɃR[hOFFɂ */
		if (!strcmp("/ac",argv[i])||!strcmp("/AC",argv[i])){ NoCode = 2; i++; continue; }
		/* sJnAhXtAZu */
		if (!strcmp("/s",argv[i])||!strcmp("/S",argv[i])){ StartFlag = 1; i++; continue; }
		/* f[^GẢ͗v */
		if (!strcmp("/d",argv[i])||!strcmp("/D",argv[i])){ DataFlag = 1; i++; continue; }
		/* TABXgo͑I */
		if (!strcmp("/ntab",argv[i])||!strcmp("/NTAB",argv[i])){ Tab = 0;i++; continue; }
		/* Rgo͑I */
		if (!strcmp("/c",argv[i])||!strcmp("/C",argv[i])){ Comment = 1;i++; continue; }
		/* Image؂oo */
		if (!strcmp("/img",argv[i])||!strcmp("/IMG",argv[i])){ OutputImg = 1;i++; continue; }
		/* R}hCُ */
		printf("Invalid Parameters.\n");
		exit(1);
	}
//	/* /sIvV̂/dL */
//	DataFlag = StartFlag ? DataFlag : 0;
	/* AZu */
	rc = DisAsmProcess( SrcFile );

	return (rc);
}

/**********************************************************************/
/*   ClearOpt : Clear Option Flag                                     */
/*                                                                    */
/*       : rIvVtO                         */
/*       : Ȃ                                                   */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void ClrOpt( void )
{
	PbfOut = 0;
	BasOut = 0;
	BinOut = 0;
	BmpOut = 0;
	DbOut = 0;
	BmpMono = 0;
	HexOut = 0;
	PjOut = 0;
	AreaFlag = 0;
}
/**********************************************************************/
/*   InitAsm : Initialize Assembler Process                           */
/*                                                                    */
/*       : AZu                                   */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int InitDisAsm( char * File )
{
unsigned int msk;
char out[8];
char * fptr;
unsigned int  cnt;	/* o̓obt@TCY */
unsigned int sum;
unsigned int line;
#if FORDOS
int data;
#endif
int max_size;
int max_y;
int n,x,y;
int rc = 0;

	/* etO/JE^ */
	ClearFlag();
	/* tAZuvȂV{ǂݍ */
	if (!BinOut && !BmpOut && !DbOut && !PbfOut && !BasOut && !PjOut && !HexOut){
		/* V{t@Cǂݍ */
		if ( ReadSymbol() != EOFERR )
			printf("Symbol read error.\n");
	}

	/* t@Cʏ */
	Ftype = 0;

	/* t@C̍쐬 */
	sprintf( LstFile , "%s" , File );

	/* gqɂt@Cʂ̔ */
	if ((int)(fptr = strrchr( LstFile,  '.' ))){
		ChgCode( oprwk , fptr );
		/* PBFt@Cł͂Ȃ */
		if ( strcmp(".PBF",oprwk ) ){
			/* BASICt@Cł */
			if ( !strcmp(".BAS",oprwk ) ) Ftype = 1;
			else {
				/* PJ HEXt@Cł */
				if ( !strcmp(".HEX",oprwk )||!strcmp(".DMP",oprwk ) ) Ftype = 2;
				else{
					/* BINt@Cł */
					if ( !strcmp(".BIN",oprwk ) ) Ftype = 3;
					else{
						/* TXTt@Cł */
						if ( !strcmp(".TXT",oprwk ) ) Ftype = 4;
						else{
							/* BMPt@Cł */
							if ( !strcmp(".BMP",oprwk ) ) Ftype = 5;
							else{
								/* Intel HEXt@Cł */
								if ( !strcmp(".IHX",oprwk ) ) Ftype = 6;
								else{
									/* ʂłȂʂȂ*.bint@Cɂ */
									Ftype = 3;
								}
							}
						}
					}
				}
			}
		}
	}
	else{
		/* ʂłȂʂȂ*.bint@Cɂ */
		Ftype = 3;
	}
	/* Listt@C쐬 */
	if (!BinOut && !BmpOut&& !PbfOut && !BasOut && !PjOut && !HexOut && !NoCode) sprintf( fptr,".lst" );
	else{
		if ( BinOut ) sprintf( fptr,".bin" );
		if ( BmpOut ) sprintf( fptr,".bmp" );
		if ( PbfOut ) sprintf( fptr,".pbf" );
		if ( BasOut ) sprintf( fptr,".bas" );
		if ( PjOut ) sprintf( fptr,".hex" );
		if ( HexOut) sprintf( fptr,".ihx" );
		if ( NoCode ) sprintf( fptr,".s" );
	}
	/* ̓t@Co̓t@CƓ̏ꍇAG[I */
	if( !strcmp(LstFile,SrcFile) ){
		printf("Invalid Source File Name.\n");
		return 1;
	}
	/* \[Xt@COPEN */
	printf( "Input : %s \n", SrcFile );
	if ( ( SrcFD = fopen( SrcFile ,"rb" ) ) <= 0 ){
		printf("Invalid File Name.\n");
		return 1;
	}
#if FORDOS
	/* e|t@COPEN */
	if ( ( TmpFD = fopen( TmpName ,"wb" ) ) <= 0 ){
		printf("Temp File not crated.\n");
		return 1;
	}
#endif
	switch ( Ftype ){
	case 0:
		/* PBFt@Cǂݏo */
		rc = ReadPbf();
		break;
	case 1:
		/* BASt@Cǂݏo */
		rc = ReadBas();
		break;
	case 2:
		/* HEXt@Cǂݏo */
		rc = ReadHex();
		break;
	case 3:
		/* BINt@Cǂݏo */
		rc = ReadBin();
		break;
	case 4:
		/* TXTt@Cǂݏo */
		rc = ReadTxt();
		break;
	case 5:
		/* BMPt@Cǂݏo */
		rc = ReadBmp();
		break;
	case 6:
		/* INTEL HEXt@Cǂݏo */
		rc = ReadIhx();
		break;
	}
	/* \[Xt@CN[Y */
	fclose(SrcFD);
#if FORDOS
	fclose(TmpFD);
#endif
	/* ǂݍ݃G[ȂAI */
	if ( rc != NORM ) return rc;

	/* f[^ȂꍇAI */
	if (!OutCnt){
		printf("File no data.\n");
		return 1;
	}
	/* sAhXُlȏꍇA␳ */
	if ( ExecAdr && ( ExecAdr < StartAdr || ExecAdr > EndAdr ) ){
		ExecAdr = 0;
	}
	/* tAZuvȂ珈I */
	if (!BinOut && !BmpOut && !PbfOut && !DbOut && !BasOut && !PjOut && !HexOut){
		return NORM;
	}
	/* o̓t@COPEN */
	if ( ( LstFD = fopen( LstFile , (BinOut||BmpOut) ? "wb" : "w" ) ) <= 0 ){
		printf("File Create Error.\n");
		return 1;
	}
#if FORDOS
	/* e|t@COPEN */
	if ( ( TmpFD = fopen( TmpName ,"rb" ) ) <= 0 ){
		printf("Temp File not crated.\n");
		return 1;
	}
#endif
	/* oCio͗v */
	if ( BinOut ){
		for ( cnt = 0 ; cnt < OutCnt ; cnt++ ){
			/* f[^o */
#if FORDOS
			fputc( fgetc(TmpFD) , LstFD );
#else
			fputc( OutBuf[cnt] , LstFD );
#endif
		}
		printf("Bin File Created.\n");
		/* ϊI */
		goto conv_end;
	}
	/* rbg}bvo͗v */
	if ( BmpOut ){
		/* rbg}bvJnAhX␳ */
		if ( BmpStart < StartAdr ) BmpStart = StartAdr;
		/* f[^ɂ摜𑜓x肷 */
		if ( OutCnt <= 768 ){
			/* BMPwb_o (192*32 pxcel) */
			for ( cnt = 0 ; cnt < 62 ; cnt++ )
				fputc( Head1[cnt] , LstFD );
			/* 摜ݒ (192*32 pxcel) */
			max_size = 768;
			max_y = 31;
		}
		else{
			/* BMPwb_o (192*64 pxcel) */
			for ( cnt = 0 ; cnt < 62 ; cnt++ )
				fputc( Head2[cnt] , LstFD );
			/* 摜ݒ (192*64 pxcel) */
			max_size = 1536;
			max_y = 63;
		}
		/* mNw(/mono) */
		if ( BmpMono ){
			/* pbgʒuɃV[N */
			fseek( LstFD , BMP_PAL_OFF , SEEK_SET );
			/* mNwpbgɒu */
			for ( cnt = 0 ; cnt < 4 ; cnt++ )
				fputc( Pmono[cnt] , LstFD );
		}
		/* C[We[u */
		memset( ImgTbl , 0xff , sizeof(ImgTbl) );
#if FORDOS
		/* ϊf[^obt@m */
		if ( !(OutBuf = malloc( (size_t)max_size ))){
			printf("Output Buffer Not Allocated.\n");
			/* ϊI */
			goto conv_end;
		}
		/* obt@ */
		memset( OutBuf , 0 , (size_t)max_size );
		/* ǂݏoʒúAe|t@Cł */
		if ( (BmpStart-StartAdr) < OutCnt ){
			/* e|t@Cǂ݂(G[͖ēǂ߂邾ǂ) */
			fseek( TmpFD, (BmpStart-StartAdr), SEEK_SET );
			fread( OutBuf , (size_t)max_size , (size_t)1 , TmpFD );
		}
#endif
		/* BMPC[Wϊ */
		y = max_y;
		x = 0;
		for( cnt = 0 ; ( cnt < (unsigned int)max_size )&&( ((BmpStart-StartAdr)+cnt) < OutCnt ) ; cnt++ ){
			/* rbg}bv肾 */
			for ( n = 0 , msk = 0x1 ; n < 8 ; n++ , msk*=2 ){
#if FORDOS
				/* rbgC[Wɕϊ */
				if( OutBuf[cnt] & msk ){
					ImgTbl[((y-n)*24)+(x/8)] ^= 0x80>>(x&7);
				}
#else
				/* rbgC[Wɕϊ */
				if ( OutBuf[(BmpStart-StartAdr)+cnt] & msk ){
					ImgTbl[((y-n)*24)+(x/8)] ^= (unsigned char)(0x80>>(x&7));
				}
#endif
			/*	printf("cnt,x,y,n,msk=%d %d %d %d %x\n",(int)cnt,(int)x,(int)y,(int)n,(int)msk); */
			}
			/* x,yXV */
			if ( ++x >=192 ){
				y-=8;
				x=0;
			}
		}
		/* BMPC[Wo */
		for ( cnt = 0 ; cnt < (unsigned int)max_size ; cnt++ ){
			fputc( ImgTbl[cnt] , LstFD );
		}
		printf("Pixel Size = 192 x %s\nBmp%sFile Created.\n", ( max_size ==768 ? "32" : "64" ),( BmpMono ? "(mono) " : " " ) );
		/* ϊI */
		goto conv_end;
	}
	/* DB`o͗v */
	if ( DbOut ){
		/* R[hJnAhXZbg */
		fprintf( LstFD , "ORG	&H%04X\n" , StartAdr );
		PrintData(  0 , OutCnt-1 );
		printf("DB format File Created.\n");
		/* ϊI */
		goto conv_end;
	}
	/* pbf/bast@C쐬v */
	if ( PbfOut||BasOut ){
		/* st@C쐬 */
		if (fptr = strrchr((const char*)LstFile,  0x5c )){
			ChgCode( ExeFile , &fptr[1] );
		}
		else{
			ChgCode( ExeFile , LstFile );
		}
		/* sAhX */
		if ( !ExecAdr ){
			/* f[^wƂ */
			sprintf( out ,".BIN" );
		}
		else{
			/* EXEwƂ */
			sprintf( out ,".EXE" );
		}
		/* gqǉ */
		if ((fptr = strrchr(ExeFile, '.' ))){
			sprintf( fptr ,"%s" ,out );
		}
		else{
			strcat( ExeFile ,out );
		}
		/* Pbft@Co */
		if( PbfOut ){
			fprintf( LstFD ,"%s,%u,%u,%u\n", ExeFile,StartAdr,EndAdr,ExecAdr );
			
			for ( cnt = 0 , n = 0 , sum = 0 ; cnt < OutCnt ; cnt ++ ){
#if FORDOS
				data = fgetc(TmpFD);
				fprintf( LstFD ,"%02X", data );
				sum += data;
#else
				fprintf( LstFD ,"%02X", OutBuf[cnt] );
				sum += OutBuf[cnt];
#endif
				n++;
				/* `FbNT/so */
				if ( n >= 120 ){
					fprintf( LstFD ,",%u\n", sum );
					n = 0;
					sum = 0;
				}
			}
			/* EOFo */
			if (n) fprintf( LstFD ,",%u\n", sum );
#if FORDOS
			fprintf( LstFD ,"%c",0x1a);
#endif
			printf("PBF format File Created.\n");
			goto conv_end;
		}
		/* BASt@Co */
		if ( BasOut ){
			line = 999;
			fprintf( LstFD ,"%d DATA %s,&H%X,&H%X,&H%X\n", line++,ExeFile,StartAdr,EndAdr,ExecAdr );
			
			for ( cnt = 0 , n = 0 , sum = 0 ; cnt < OutCnt ; cnt ++ ){
				/* sԍo */
				if (!n) fprintf( LstFD ,"%d DATA ", line++ );
#if FORDOS
				data = fgetc(TmpFD);
				fprintf( LstFD ,"%02X", data );
				sum += data;
#else
				fprintf( LstFD ,"%02X", OutBuf[cnt] );
				sum += OutBuf[cnt];
#endif
				n++;
				/* `FbNT/so */
				if ( n >= 8 ){
					fprintf( LstFD ,",%02X\n", sum&0xff );
					n = 0;
					sum = 0;
				}
			}
			/* EOFo */
			if (n) fprintf( LstFD ,",%02X\n", sum&0xff );
#if FORDOS
			fprintf( LstFD ,"%c",0x1a);
#endif
			printf("BASIC format File Created.\n");
			goto conv_end;
		}
	}
	/* PJ HEXt@Co */
	if ( PjOut ){
		for ( cnt = 0 , n = 0 , sum = 0 ; cnt < OutCnt ; cnt ++ ){
#if FORDOS
			/* AhXo */
			if (!n) fprintf( LstFD ,"%04X ", (unsigned int)StartAdr );
			data = fgetc(TmpFD);
			fprintf( LstFD ,"%02X", data );
			sum += data;
#else
			/* AhXo */
			if (!n) fprintf( LstFD ,"%04X ", StartAdr );
			fprintf( LstFD ,"%02X", OutBuf[cnt] );
			sum += OutBuf[cnt];
#endif
			n++;
			/* `FbNT/so */
			if ( n >= 8 ){
				fprintf( LstFD ,":%02X\n", sum&0xff );
				StartAdr += n;
				n = 0;
				sum = 0;
			}
		}
		/* EOFo */
		if (n) fprintf( LstFD ,":%02X\n", sum&0xff );
#if FORDOS
		fprintf( LstFD ,"%c",0x1a);
#endif
		printf("PJ HEX format File Created.\n");
		goto conv_end;
	}
	/* Intel HEX(8bit)t@Co */
	if ( HexOut ){
		for ( cnt = 0 , n = 0 , sum = 0 ; cnt < OutCnt ; cnt ++ ){
			/* oCg/AhX/f[^ʂo */
			if (!n){
#if FORDOS
				fprintf( LstFD ,":%02X",( (OutCnt-cnt)>=16 ? 16:(OutCnt-cnt) ) );
				fprintf( LstFD ,"%04X00",(unsigned int)StartAdr );
#else
				fprintf( LstFD ,":%02X%04X00",( (OutCnt-cnt)>=16 ? 16:(OutCnt-cnt) ),StartAdr );
#endif
				sum = ( (OutCnt-cnt)>=16 ? 16:(OutCnt-cnt) ) + (StartAdr>>8) + (StartAdr&0xff);
			}
			/* f[^1oCg o */
#if FORDOS
			data = fgetc(TmpFD);
			fprintf( LstFD ,"%02X", data );
			sum += data;
#else
			fprintf( LstFD ,"%02X", OutBuf[cnt] );
			sum += OutBuf[cnt];
#endif
			n++;
			/* `FbNT/so */
			if ( n >= 16 ){
				fprintf( LstFD ,"%02X\n", (0x100-(sum&0xff))&0xff );
				StartAdr += n;
				n = 0;
				sum = 0;
			}
		}
		/* `FbNTói[j */
		if (n) fprintf( LstFD ,"%02X\n", (0x100-(sum&0xff))&0xff );
		/* AJ[o */
		fprintf( LstFD ,"%s",":00000001FF\n" );
#if FORDOS
		/* EOFo */
		fprintf( LstFD ,"%c",0x1a);
#endif
		printf("INTEL HEX format File Created.\n");
	}
conv_end:
	/* Xgt@CN[Y */
	fclose(LstFD);
#if FORDOS
	/* e|t@CN[Y */
	fclose(TmpFD);
#endif
	/* tAZuI */
	return 1;
}

/**********************************************************************/
/*   ClearFlag : Clear Flag Data                                      */
/*                                                                    */
/*       : etO                                       */
/*       : Ȃ                                                   */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void ClearFlag( void )
{
	/* AZuJnAhX */
	AsmAdr = 0;
	ExecAdr = 0;
	StartAdr = 0;
	EndAdr = 0;
	LblAdr = 0xffff;
	BuffSize = 0;
	/* o̓obt@|C^ */
	OutCnt = 0;
	OutBuf = 0;
	/* LABELe[u */
	LabelCnt = 0;
	LabelTbl = 0;
#if _Support_SA
	/* SÄo^e[u */
	AreaCnt=0;
	AreaTbl=0;
#endif /* _Support_SA */
	
	AsmFlag = 0;/* AZu */
	IfLevel = 0;
	memset( IfStk , 0 , sizeof(IfStk) );
	/* includepϐ */
	IncLevel = 0;
	memset( IncFD , 0 , sizeof(IncFD));
}

/**********************************************************************/
/*   DspWarn : Display Warning Macro                                  */
/*                                                                    */
/*       : WARNING \p }N`                              */
/*                                                                    */
/**********************************************************************/
#define DspWarn() if( rc != NORM ){ \
/* ̓R[hɊYG[bZ[Wo */ \
	for ( i = 0 ; i < MAXERR-1 ; i++ ){ \
		if ( errtbl[i].code==rc )	break; \
	} \
	/* G[bZ[W\ */ \
	printf("WARNING CODE:%03d %s\n" , rc , errtbl[i].msg ); \
	/* G[s\ */ \
	printf(" %s\n" , Work ); \
	/* @G[͋ɗ͖Ď̍sɍs */ \
	rc = NORM; \
}
/**********************************************************************/
/*   ReadSymbol : Read Symbole File                                   */
/*                                                                    */
/*       : V{t@Cǂݍ                             */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadSymbol( void )
{
char Work[MAXLINE+2];/* sf[^擾p[N */
int  rc,opr,i,len;
unsigned int	op,sts;
unsigned int	adr,size,type,div;
FILE	*SourceFD;/* \[Xt@CfBXNv^ */

	/* hsymbol.hht@COPEN */
	if ( ( SymbolFD = fopen( "symbol.h" ,"rb" ) ) <= 0 ){
		return EOFERR;
	}
	printf("Read Symbol file.\n");

	/* G[Xe[^X */
	rc = 0;
	while(!rc){
		/* R[hϊobt@ */
		memset( &OutTbl.adr,0, sizeof(OUTTBL));
		/* s[Nobt@ */
		memset( Work , 0 , MAXLINE );
		/* t@C؂ւ */
		/* t@C؂ւ */
		SourceFD = !IncLevel ? SymbolFD : IncFD[IncLevel-1];

		/* \[Xt@CPso */
		if ( rc = GetLine( SourceFD , Work ) ){
			/* CN[ht@CI */
			if ( rc == EOFERR && IncLevel ){
				IncLevel--;
				fclose( IncFD[IncLevel] );
				IncFD[IncLevel] = 0;
				rc = 0;
			}
			continue;
		}
		if ( !Work[0] ) continue;

		/* x/jjbN/Iyhɕ */
		if( rc = GetParam( Work ) ) continue;

		/******************************************/
		/* #if`#else`#endif}N           */
		/******************************************/
		/* jjbNo^ */
		if ( OutTbl.opr[0][0] ){
			/* ^ߎʃ`FbN */
			ChgCode( oprwk , OutTbl.opr[0] );
			opr = GetMacKind( oprwk );
			switch( opr ){
			case OP_IF:
				/* xIyh2Gg */
				if ( OutTbl.label[0] || OutTbl.opr[2][0] ){ rc = ILLOPR; continue; }
				/* 1Iyhł */
				if( rc = GetCalcData( OutTbl.opr[1] , &op , &sts ) ) continue;
				/* ̂ȏꍇAI */
				if ( op == LBLNG ){ rc = LBLNOENT; continue; }
				/* lXgxAsmFlagۑ */
				IfStk[IfLevel] = AsmFlag;
				/* AZuԂł */
				if (!AsmFlag){
					/* AZu֎~/Zbg */
					AsmFlag = (unsigned char)(sts ? 0 : (!AsmFlag ? 1 : 2 ));
				}
				/* #iflXgx+1 */
				IfLevel++;
				/* lXgxI[o[ */
				if (IfLevel>=IFLEVEL){ rc = IFNEST; continue; }
				break;
			case OP_ELSE:
				/* xIyhGg */
				if ( OutTbl.label[0] || OutTbl.opr[1][0] ){ rc = ILLOPR; continue; }
				if ( !IfLevel ){ rc = IFNEST; continue; }
				/* ʃlXg̓AZu */
				if ( !IfStk[IfLevel-1] ){
					/* AZuԔ] */
					AsmFlag = (unsigned char)(AsmFlag ? 0 : 1);
				}
				break;
			case OP_ENDIF:
				/* xIyhGg */
				if ( OutTbl.label[0] || OutTbl.opr[1][0] ){ rc = ILLOPR; continue; }
				if ( !IfLevel ){ rc = IFNEST; continue; }
				/* #iflXgx-1 */
				IfLevel--;
				if ( IfLevel < 0 ) { rc= IFNEST; continue; }
				/* AZuĊJ */
				AsmFlag = IfStk[IfLevel];
				break;
			default:
				break;
			}
		}
		/* AZu֎~ȂA̍s */
		if ( AsmFlag ) continue;

		/* ":"Ȃx */
		if ( !OutTbl.label[0] && OutTbl.opr[1] ){
			/* EQU߂ł */
			ChgCode( oprwk , OutTbl.opr[1] );
			if ( !memcmp( "EQU" , oprwk ,3 ) ){
				/* x`FbN */
				if ( strlen(OutTbl.opr[0])>MAXLBL ){
					rc= LBOFLOW;
					continue;
				}
				/* xƂēo^ */
				strcpy( OutTbl.label , OutTbl.opr[0] );
				memcpy( OutTbl.opr[0] ,OutTbl.opr[1], 3 );
				OutTbl.opr[0][3] = 0;
				strcpy( OutTbl.opr[1] , &OutTbl.opr[1][3] );
				OutTbl.opr[2][0] = 0;
			}
#if _Support_SA
			if (!memcmp( "SA" , oprwk ,2 )){
				/* x`FbN */
				if ( strlen(OutTbl.opr[0])>MAXLBL ){
					printf("Label too long.[%s]",OutTbl.opr[0]);
					rc= LBOFLOW;
					continue;
				}
				/* xƂēo^ */
				strcpy( OutTbl.label , OutTbl.opr[0] );
				if ((oprwk[2]=='W')||(oprwk[2]=='S')||(oprwk[2]=='B')){
					/* jjbN+^CvRs[ */
					memcpy( OutTbl.opr[0] ,OutTbl.opr[1], 3 );
					OutTbl.opr[0][3] = 0;
					strcpy( OutTbl.opr[1] , &OutTbl.opr[1][3] );
				}
				else{
					/* jjbNRs[ */
					memcpy( OutTbl.opr[0] ,OutTbl.opr[1], 2 );
					OutTbl.opr[0][2] = 0;
					strcpy( OutTbl.opr[1] , &OutTbl.opr[1][2] );
				}
			}
#endif /* _Support_SA */
		}
		/* x */
		if ( OutTbl.label[0] ){
			/* x`FbN */
			if ( rc = CheckLabel(OutTbl.label) ) continue;
			/* EQUvł */
			ChgCode( oprwk , OutTbl.opr[0] );
			if (!strcmp( "EQU" , oprwk )){
				/* IyhGgȂ */
				if ( !OutTbl.opr[1] ){ rc = ILLOPR; continue;}
				/* 1Iyhlł */
				if( !(rc = GetCalcData( OutTbl.opr[1] ,&op, &sts )) ){
					/* ̂ȏꍇAI */
					if ( op == LBLNG ) break;
					/* xe[uɓo^ */
					rc = SetLabelEntry( &OutTbl , sts );
					/* [jO\ */
					DspWarn();
				}
				else break;
			}
#if _Support_SA
			/* SA(Set Area)߂ł */
			else if ( !memcmp( "SA" ,oprwk ,2 )){
				/*㑱̏{ */;
			}
#endif /* _Support_SA */
			/* sjjbNƂ */
			else{
				rc= UNDEFOPR;
				break;
			}
		}
#if _Support_SA
		/* jjbNo^ */
		if ( OutTbl.opr[0][0] ){
			/* SA(Set Area)߂ł */
			ChgCode( oprwk , OutTbl.opr[0] );
			if ( !memcmp( "SA" ,oprwk ,2 )&& ( strlen( oprwk ) <= 3 ) ){
				size = 1;
				div = 0;
				/* (type)擾 */
				switch(oprwk[2])
				{
				/* [h(word)w */
				case 'W':
					type = SA_DW;
					size = 2;
					break;
				/* (ascii)w */
				case 'S':
					type = SA_STR;
					break;
				/* oCi(binary)w */
				case 'B':
					type = SA_BIN;
					break;
				/* ̑(byte) */
				default:
					type = SA_DB;
					break;
				}
//				printf("SA [%s][%s][%s][%s] type=%d\n",oprwk,OutTbl.opr[1],OutTbl.opr[2],OutTbl.opr[3],type);
				/* 1Iyhł */
				if( rc = GetCalcData( OutTbl.opr[1] , &op , &sts ) ) continue;
				/* ̂ȏꍇAI */
				if ( op == LBLNG ){ rc = LBLNOENT; continue; }
				/* [N̈擪AhX擾 */
				adr = sts;
				/* Iyh2Gg */
				if ( strlen(OutTbl.opr[2])>0 ){
					/* 2Iyhł */
					if( rc = GetCalcData( OutTbl.opr[2] , &op , &sts ) ) continue;
					/* ̂ȏꍇAI */
					if ( op == LBLNG ){ rc = LBLNOENT; continue; }
					/* 擪AhXŏIAhXꍇ͎̓ǂݍ */
					if ( adr > sts ){ rc = ILLOPR; continue; }
					/* [N̈TCY */
					size = (sts - adr) + 1;
				}
				/* Iyh3Gg */
				if ( strlen(OutTbl.opr[3])>0 ){
					/* 3Iyhł */
					if( rc = GetCalcData( OutTbl.opr[3] , &op , &div ) ) continue;
					/* ̂ȏꍇAI */
					if ( op == LBLNG ){ rc = LBLNOENT; continue; }
					/* ̈TCYAp敝傫ꍇ̓G[Ƃ */
					if ( div > size ){ rc = ILLOPR; continue; }
				}
				/* [NGAo^ */
				rc = SetAreaTbl( (unsigned char)type , adr , size , div );
				/* x */
				if ( OutTbl.label[0] ){
					/* x`FbN */
					if ( rc = CheckLabel(OutTbl.label) ) continue;
					/* xe[uɓo^ */
					rc = SetLabelEntry( &OutTbl , adr );
					/* [jO\ */
					DspWarn();				}
			}
		}
#endif /* _Support_SA */
		/* jjbNo^ */
		if ( OutTbl.opr[0][0] ){
			/* ^ߎʃ`FbN */
			ChgCode( oprwk , OutTbl.opr[0] );
			if ( !memcmp( "INCLUDE" ,oprwk ,7 ) ){
				/* ɃCN[ht@COPEN */
				if ( IncLevel >= (MAXINC-1) ){
					printf("Could Not Nest Include.\n");
					rc = INCERR;
					continue; 
				}
				/* IyhGg */
				if ( !OutTbl.opr[1] ){
					printf("Invalid Include File Name.\n");
					rc = ILLOPR;
					continue;
				}
				if ( (len = strlen(OutTbl.opr[1])) < 3 ){ rc = INCNOFILE; continue; }
				/* 擪эŏI͊ʂł */
				if ( ( OutTbl.opr[1][0] == '(' ) && ( OutTbl.opr[1][len-1] == ')' ) ){
					/* CN[ht@Co */
					memset( IncFile , 0 , sizeof(IncFile) );
					memcpy( IncFile , &OutTbl.opr[1][1] , len-2 );
					/* CN[ht@COPEN */
					if ( ( IncFD[IncLevel] = fopen( IncFile ,"rb" ) ) <= 0 ){
						printf("Invalid Include File Name.\n");
						rc = INCNOFILE;
						break; 
					}
					/* includet@C\ */
					printf("%s%s\n",OutTbl.opr[0],OutTbl.opr[1]);
					/* CN[hLEVELXV */
					IncLevel++;
					rc = NORM;
				}
				else{
					printf("Invalid Include File Name.\n");
					rc = INCNOFILE;
				}
			}
		}		/* RgL */
		if ( OutTbl.comment[0] ){
		}
	}
	/* G[ */
	if( rc != EOFERR ){
		/* ̓R[hɊYG[bZ[Wo */
		for ( i = 0 ; i < MAXERR-1 ; i++ ){
			if ( errtbl[i].code==rc )	break;
		}
		/* G[bZ[W\ */
		printf("ERROR CODE:%03d %s\n" , rc , errtbl[i].msg );
		/* G[s\ */
		printf(" %s\n" , Work );
	}
	if ( IncLevel ){
		for ( i = 0 ; i < IncLevel ;i++){
			fclose( IncFD[i] );
		}
	}

	/* t@CN[Y */
	fclose(SymbolFD);
	return rc;
}

/**********************************************************************/
/*   GetMacKind : Get Macro Kind                                      */
/*                                                                    */
/*       : }Nʂ肷                                   */
/*       : Iyh|C^                                     */
/*   o    : jjbN                                         */
/*                                                                    */
/**********************************************************************/
int GetMacKind( char * buff )
{
int	i;
	/* ^߃e[uT[` */
	for ( i = 0 ; i < MACDIR ; i++ ){
		if (!strcmp( buff , MacTbl[i].name ))
			/* ^߃R[hԂ */
			return MacTbl[i].code;
	}
	/* YȂiʖ߁jԂ */
	return UNDEFOPR;
}

/**********************************************************************/
/*   GetLine : Get Source Line                                        */
/*                                                                    */
/*       : \[Xt@CPs̕擾             */
/*       : \[Xt@C                                       */
/*       : ̓t@ChcAo̓obt@|C^                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetLine( FILE *fd ,char *buff )
{
int	sts;
int	i;
	/* 1sI܂Ŏo */
	for( i = 0 ; i < MAXLINE ; i++ ){
		/* 1o */
		sts = fgetc( fd );
		switch ( sts ){
		case '\r':
			break;
		case '\n':
			/* PsI */
			return NORM;
		case 0x1a:
		case EOF:
			/* t@CI */
			return EOFERR;
		default:
			*buff++ = ( char )sts;
			break;
		}
	}
	return LOFLOW;
}

/**********************************************************************/
/*   GetLine : Get Source Line                                        */
/*                                                                    */
/*       : \[Xt@CPs̕擾             */
/*       : \[Xt@C                                       */
/*       : ̓t@ChcAo̓obt@|C^                 */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetLine2( FILE *fd ,char *buff )
{
int	sts;
int	i;
	/* 1sI܂Ŏo */
	for( i = 0 ; i < MAXLINE ; i++ ){
		/* 1o */
		sts = fgetc( fd );
		switch ( sts ){
		case 0x20:
		case '\t':
		case '\r':
			break;
		case '\n':
		case ';':
		case 0x27:
			/* PsI */
			return NORM;
		case 0x1a:
		case EOF:
			/* t@CI */
			return EOFERR;
		default:
			*buff++ = ( char )sts;
			break;
		}
	}
	return LOFLOW;
}

/**********************************************************************/
/*   GetParam : Get Parameter String                                  */
/*                                                                    */
/*       : ep[^擾                           */
/*       : sobt@|C^                                     */
/*   o    : G[i0:A0ȊO:YȂj             */
/*                                                                    */
/**********************************************************************/
/* 
 F^ꂽ[Nobt@̕p[^ɕOutTblɓo^B
       Tv͈ȉ̒ʂB
      (1)^u^Xy[X͍폜B
      (2)ŏ̕ɃR[:]oƃxƂĊi[B
*/
int GetParam( char *buff )
{
int kakko;
int	len;
int	j,n;
int label;

	/* 1sI܂Ŏo */
	len = strlen( buff );
	for(  j = 0 , n = 0 ,label = 0 ,kakko = 0 ; ( n < MAXOPR )&&( j <len ) ; buff++ ){
		switch ( *buff ){
		case '#':
		case ';':
			/* Rgo */
#if FORDOS
			buff[MAXCOMM]=0;
			sprintf(OutTbl.comment,"%s",buff+1);
#else
			snprintf(OutTbl.comment,MAXCOMM,"%s",buff+1);
#endif
			return NORM;
		case '\n':
		case 0x0:
			/* soŏI */
			return NORM;
		case ':':
			/* xo */
			if ( !label && !n ){
				/* xo^ */
				if ( j > MAXLBL ) return LBOFLOW;
				sprintf( OutTbl.label,"%s",&OutTbl.opr[0][0]);
				memset(OutTbl.opr[0] ,0,32);
				/* i[obt@|C^XV */
				j = 0;
				label++;
				break;
			}
			/* Qdx̓G[I */
			else if (!n) return DUPLBL;
			return ILLOPR;
		case ',':
			if ( j ){
				/* s */
				n++;
				j = 0;
			}
			break;
		case 0x20:
		case '\t':
			/* jjbNo^Ȃ΁As */
			if ( !n && j ){
				/* s */
				n++;
				j = 0;
			}
			break;
		case ')':
			/* p[^o^ */
			OutTbl.opr[n][j++]=*buff;
			/* Ƃʌo */
			if ( kakko ){
				kakko--;
				break;
			}
			/* G[I */
			else  return ILLDQUO;
			break;
		case '(':
			/* ʌo */
			kakko++;
			/* jjbNo^Ȃ΁As */
			if ( !n && j ){
				/* s */
				n++;
				j = 0;
			}
		default:
			/* LȊȌꍇAp[^o^ */
			OutTbl.opr[n][j++]=*buff;
			break;
		}
		/* őIyhzꍇAI */
		if ( j >= MAXLEN ) return OPOFLOW;
	}
	return 0;
}

/**********************************************************************/
/*   ReadPbf : Read PBF file                                          */
/*                                                                    */
/*       : PBFtH[}bg̃t@COutBufobt@ɓǂݏo    */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadPbf( void )
{
char Work[MAXLINE+2];/* sf[^擾p[N */
char out[8];
char * fptr;
unsigned int data,sum,chksum;
int rc;
int n,len;

	/* s[Nobt@ */
	memset( Work , 0 , MAXLINE );
	/* PBFt@CPso */
	if ( rc = GetLine( SrcFD , Work ) ){
		printf("PBF File Read Error.\n");
		return 1;
	}

	/* ́AJnAhXAIAhXAsAhX擾 */
	memset( ExeFile , 0 , sizeof(ExeFile) );
	if (!(fptr = strchr( Work, ',' ))){
		printf("PBF File Read Error.\n");
		return 1;
	}
	memcpy( ExeFile , Work , (int)(fptr-Work));
	if ( sscanf( fptr+1 ,"%Ld,%Ld,%Ld",&StartAdr,&EndAdr,&ExecAdr ) != 3){
		printf("PBF File Read Error.\n");
		return 1;
	}
	/* AhXlُ */
	if ( StartAdr > EndAdr || EndAdr > 65535 ){
		printf("Illigal address data\n");
		return 1;
	}
	/* o̓obt@mۂ */
	BuffSize = (EndAdr - StartAdr) + 1;
#if !FORDOS
	if ( !(OutBuf = malloc( (size_t)BuffSize ))){
		printf("Output Buffer Not Allocated.\n");
		return 1;
	}
	/* obt@ */
	memset( OutBuf, 0 , (size_t)BuffSize );
#endif
	memset( out , 0 , 4 );
	OutCnt = 0;
	rc = 0;
	/* PBF --> oCiϊ */
	while( !rc ){
		/* s[Nobt@ */
		memset( Work , 0 , MAXLINE );
		memset( oprwk , 0 , MAXLINE );
		/* PBFt@CPso */
		rc = GetLine2( SrcFD , Work );
		if (!Work[0]){ rc = 1; break;}
		/* PBFo */
		if (!(fptr = strchr( Work, ',' ))){
			printf("PBF File Read Error.\n");
			return 1;
		}
		memcpy( oprwk , Work , (int)(fptr-Work));
		/* `FbNTo */
		sscanf( fptr+1 , "%u" ,  &chksum );
		len = strlen( oprwk );
		/* f[^ϊ */
		for ( n = 0 , sum = 0 ; n < len ; n += 2 ){
			/* PUiɕϊ */
			memcpy( out ,&oprwk[n] , 2 );
			if ( sscanf( out , "%X" , &data ) == EOF ){
				printf("%s\n" , Work );
				printf("Illigal data\n");
				return 1;
			}
			/* f[^i[ */
#if FORDOS
			fprintf( TmpFD, "%c", (char)data );
			OutCnt++;
#else
			OutBuf[OutCnt++] = (char)data;
#endif
			sum += data;
		}
		/* `FbNT */
		if ( sum != chksum ){
			printf("%s\n" , Work );
			printf("Sum Error. %d %d\n",len,sum );
			return 1;
		}
	}
	return NORM;
}

/**********************************************************************/
/*   ReadBAS : Read BAS file                                          */
/*                                                                    */
/*       : BASICtH[}bg̃t@COutBufobt@ɓǂݏo  */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadBas( void )
{
char Work[MAXLINE+2];/* sf[^擾p[N */
char out[8];
char * fptr;
unsigned int data,sum,chksum;
int rc;
int n,len;

	/* AhX񂪖 */
	if (!AdrSet){
		printf("Address not defined.\n");
		return 1;
	}
	/* JnAhXAsAhXݒ */
	StartAdr = (unsigned int)Adrs[0];
	if (AdrSet>=2) ExecAdr = (unsigned int)Adrs[1];

	/* AhXlُ */
	if ( StartAdr > 65535 ){
		printf("Illigal Address\n");
		return 1;
	}
	/* o̓obt@mۂ(StartAdrȂ̂Ŏ肠őŎ) */
	BuffSize = 65536 - StartAdr;
#if !FORDOS
	if ( !(OutBuf = malloc( (size_t)BuffSize ))){
		printf("Output Buffer Not Allocated. %d %d\n",StartAdr,BuffSize);
		return 1;
	}
	/* obt@ */
	memset( OutBuf, 0 , (size_t)BuffSize );
#endif
	memset( out , 0 , 4 );
	OutCnt = 0;
	rc = 0;
	/* BAS --> oCiϊ */
	while( !rc ){
		/* s[Nobt@ */
		memset( Work , 0 , MAXLINE );
		memset( oprwk , 0 , MAXLINE );
		/* PBFt@CPso */
		rc = GetLine2( SrcFD , Work );
		if (!Work[0]){ rc = 1; break;}
		/* DATA  */
		len = strlen(Work);
		for ( n = 0,fptr = 0 ; n < (len-4) ; n++ )
			if ( !memcmp( &Work[n] ,"DATA",4 ) ) break;
		if ( n >= (len-4) ){
			continue;
#if 0
			/* G[s̕\ */
			printf( "%s\n" , Work );
			printf("BAS File Read Error.\n");
			return 1;
#endif
		}
		n = n+4;
		/* f[^o */
		if (!(fptr = strchr( &Work[n], ',' ))){
			printf( "%s\n" , Work );
			printf("BAS File Read Error.\n");
			return 1;
		}
		/* `FbNT(16i)o */
		sscanf( fptr+1 , "%x" ,  &chksum );
		/* f[^o */
		memcpy( oprwk , &Work[n] , (int)(fptr-&Work[n]));

		len = strlen( oprwk );
		/* f[^ϊ */
		for ( n = 0 , sum = 0 ; n < len ; n += 2 ){
			/* PUiɕϊ */
			memcpy( out ,&oprwk[n] , 2 );
			if ( sscanf( out , "%X" , &data ) == EOF ){
				printf("%s" , Work );
				printf("Illigal data\n");
				return 1;
			}
			/* f[^i[ */
#if FORDOS
			fprintf( TmpFD, "%c", (char)data );
#else
			OutBuf[OutCnt] = (char)data;
#endif
			sum += data;
			/* obt@|C^XV */
			if ( ++OutCnt > BuffSize ){
				/* obt@I[o[ */
				printf("%s\n" , Work );
				printf("Buffer over flow.\n");
				return 1;
			}
		}
		/* `FbNT */
		if ( (sum&0xff) != chksum ){
			printf( "%s\n" , Work );
			printf("Sum Error. %d %x %x\n",len,sum,chksum );
			return 1;
		}
	}
	/* IAhXZbg */
	EndAdr = StartAdr + OutCnt - 1;
	return NORM;
}

/**********************************************************************/
/*   ReadHex : Read HEX file                                          */
/*                                                                    */
/*       : PJ HEXtH[}bg̃t@COutBufobt@ɓǂݏo */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadHex( void )
{
char Work[MAXLINE+2];/* sf[^擾p[N */
char out[8];
unsigned int  curadr,adr,BuffSize;	/* o̓obt@TCY */
unsigned int data,sum,chksum;
int rc,ac;
int n,m,len;

	/* AhX擾 */
	if ( AdrSet ){
		/* sAhXݒ */
		ExecAdr = (unsigned int)Adrs[0];
	}
	/* obt@ */
	memset( out , 0 , sizeof(out) );
	OutCnt = 0;
	rc = 0;
	ac = 0;
	/* HEX --> oCiϊ */
	while( !rc ){
		/* s[Nobt@ */
		memset( Work , 0 , MAXLINE );
		memset( oprwk , 0 , MAXLINE );
		/* PBFt@CPso */
		rc = GetLine2( SrcFD , Work );
		if (!Work[0]) continue;

		len = strlen(Work);
		/* AhXo */
		memcpy(oprwk , Work ,4 );
#if FORDOS
		if ( sscanf( oprwk , "%LX" , &adr ) == EOF ){
#else
		if ( sscanf( oprwk , "%X" , &adr ) == EOF ){
#endif
			printf("%s\n" , Work );
			printf("Illigal Address\n");
			return 1;
		}
		/* AhXlُ */
		if ( adr > 65535 ){
			printf("%s\n" , Work );
			printf("Illigal Address\n");
			return 1;
		}
		/* o^ł */
		if ( !ac ){
			/* AhXo^ */
			StartAdr = adr;
			curadr = adr;
			ac++;
			/* o̓obt@mۂ(StartAdrȂ̂Ŏ肠őŎ) */
			BuffSize = 65536 - StartAdr;
#if !FORDOS
			if ( !(OutBuf = malloc( (size_t)BuffSize ))){
				printf("Output Buffer Not Allocated.\n");
				return 1;
			}
			/* obt@ */
			memset( OutBuf, 0 , (size_t)BuffSize );
#endif
		}
		/* AhXXV͐ł */
		if ( curadr != adr ){
			printf("%s\n" , Work );
			printf("Illigal Address %x %x\n",curadr ,adr);
			return 1;
		}
		/* `FbNT(16i)o */
		len = strlen( Work );
		if ( sscanf( &Work[len-2] , "%x" ,  &chksum ) == EOF ){
			printf("%s\n" , Work );
			printf("Illigal data\n");
			return 1;
		}
		n = 4;
		m = len - 3;
		/* AhX̎f[^΂ */
		if ( Work[n]==':'||Work[n]==',' ) n++;
		if ( Work[m]==':'||Work[m]==',' ) m--;
		len = m - n + 1;
		memcpy( oprwk , &Work[n] , len );

		/* f[^ϊ */
		for ( n = 0 , sum = 0 ; n < len ; n += 2 ){
			/* PUiɕϊ */
			memcpy( out ,&oprwk[n] , 2 );
			if ( sscanf( out , "%X" , &data ) == EOF ){
				printf("%s\n" , Work );
				printf("Illigal data\n");
				return 1;
			}
			/* f[^i[ */
#if FORDOS
			fprintf( TmpFD, "%c", (char)data );
			OutCnt++;
#else
			OutBuf[OutCnt++] = (char)data;
#endif
			sum += data;
			/* AhXُ */
			if ( curadr > 65535 ){
				/* obt@I[o[ */
				printf("%s\n" , Work );
				printf("Buffer over flow.\n");
				return 1;
			}
			/* AhXXV */
			curadr++;
		}
		/* `FbNT */
		if ( (sum&0xff) != chksum ){
			printf( "%s\n" , Work );
			printf("Sum Error. %d %x %x\n",len,sum,chksum );
			return 1;
		}
	}
	/* IAhXZbg */
	EndAdr = StartAdr + OutCnt - 1;
	return NORM;
}

/**********************************************************************/
/*   ReadBin : Read BIN file                                          */
/*                                                                    */
/*       : BinarytH[}bg̃t@COutBufobt@ɓǂݏo */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadBin( void )
{
#if FORDOS
	unsigned int i;
#endif
	/* AhX񂪖 */
	if (!AdrSet){
		printf("Address not defined.\n");
		return 1;
	}
	/* JnAhXAsAhXݒ */
	StartAdr = (unsigned int)Adrs[0];
	if (AdrSet>=2) ExecAdr = (unsigned int)Adrs[1];
	/* AhXlُ */
	if ( StartAdr > 65535 ){
		printf("Illigal Address. %u\n",StartAdr);
		return 1;
	}
	/* t@CTCY擾 */
	if (fseek( SrcFD , 0 , SEEK_END )){
		printf("File seek error.\n");
		return 1;
	}
	BuffSize = (unsigned int)ftell( SrcFD );
	if (fseek( SrcFD , 0 , SEEK_SET )){
		printf("File seek error.\n");
		return 1;
	}
	/* obt@TCY␳ */
	BuffSize = ( BuffSize > ( 65536 - StartAdr )) ? ( 65536 - StartAdr ) : BuffSize;
#if !FORDOS
	/* o̓obt@mۂ */
	if ( !(OutBuf = malloc( (size_t)BuffSize ))){
		printf("Output Buffer Not Allocated.\n");
		return 1;
	}
	/* obt@ */
	memset( OutBuf, 0 , (size_t)BuffSize );
	/* BINt@Cǂ݂ */
	if ( fread( OutBuf , (size_t)BuffSize , (size_t)1 , SrcFD ) != 1 ){
		printf("File read error.\n");
		return 1;
	}
#else
	for ( i = 0 ; i < BuffSize ; i++ ){
		fprintf( TmpFD, "%c", fgetc(SrcFD) );
	}
#endif
	/* IAhXZbg */
	OutCnt = BuffSize;
	EndAdr = StartAdr + OutCnt - 1;
	return NORM;
}

/**********************************************************************/
/*   ReadTxt : Read Txt file                                          */
/*                                                                    */
/*       : TEXTtH[}bg̃t@COutBufobt@ɓǂݏo   */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadTxt( void )
{
char out[8];
unsigned int data;
int rc;
int n,len;

	/* AhX񂪖 */
	if (!AdrSet){
		printf("Address not defined.\n");
		return 1;
	}
	/* JnAhXAsAhXݒ */
	StartAdr = (unsigned int)Adrs[0];
	if (AdrSet>=2) ExecAdr = (unsigned int)Adrs[1];
	/* AhXlُ */
	if ( StartAdr > 65535 ){
		printf("Illigal Address. %u\n",StartAdr);
		return 1;
	}

	/* o̓obt@mۂ(StartAdrȂ̂Ŏ肠őŎ) */
	BuffSize = 65536 - StartAdr;
#if !FORDOS
	if ( !(OutBuf = malloc( (size_t)BuffSize ))){
		printf("Output Buffer Not Allocated.\n");
		return 1;
	}
	/* obt@ */
	memset( OutBuf, 0 , (size_t)BuffSize );
#endif
	memset( out , 0 , 4 );
	OutCnt = 0;

	rc = 0;
	/* ASCII --> oCiϊ */
	while( !rc ){
		/* s[Nobt@ */
		memset( oprwk , 0 , MAXLINE );
		/* t@CPso */
		rc = GetLine2( SrcFD , oprwk );
		if (!oprwk[0]) continue;

		len = strlen( oprwk );
		/* f[^ϊ */
		for ( n = 0 ; n < len ; n += 2 ){
			/* PUiɕϊ */
			memcpy( out ,&oprwk[n] , 2 );
			if ( sscanf( out , "%X" , &data ) == EOF ){
				printf("%s" , oprwk );
				printf("Illigal data\n");
				return 1;
			}
			/* f[^i[ */
#if FORDOS
			fprintf( TmpFD, "%c", (char)data );
#else
			OutBuf[OutCnt] = (char)data;
#endif
			/* obt@|C^XV */
			if ( ++OutCnt > BuffSize ){
				/* obt@I[o[ */
				printf("%s\n" , oprwk );
				printf("Buffer over flow.\n");
				return 1;
			}
		}
	}
	/* IAhXZbg */
	EndAdr = StartAdr + OutCnt - 1;
	return NORM;
}

/**********************************************************************/
/*   ReadBmp : Read Bitmap file                                       */
/*                                                                    */
/*       : BMPtH[}bg̃t@COutBufobt@ɓǂݏo    */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadBmp( void )
{
unsigned int bfsize;	/* t@CTCY */
unsigned int boffset;	/* 摜f[^܂ł̃ItZbg */
unsigned int bisize;	/* wb_̑傫 */
unsigned int width;	/* 摜̕ */
unsigned int width2;	/* 摜̕(ۂ̃f[^ʒu) */
unsigned int height;	/* 摜̍ */
//unsigned int imgsize;	/* 摜̃TCY */
unsigned int bitcount;/* F */
unsigned int parret1,parret2;/* pbgf[^ */
unsigned int x,y;
unsigned char * ImageTbl=0;/* ǂݏopobt@|C^ */
unsigned int ImgSize=0;	/* 摜obt@TCY */

	/* AhX񂪖 */
	if (!AdrSet){
		/* AhX0JnƂ(fBtHg) */
		StartAdr = 0;
		ExecAdr = 0;
	}
	else{
		/* JnAhXݒ */
		StartAdr = (unsigned int)Adrs[0];
	}
	/* sAhXݒ */
	if (AdrSet>=2) ExecAdr = (unsigned int)Adrs[1];
	/* AhXlُ */
	if ( StartAdr > 65535 ){
		printf("Illigal Address. %u\n",StartAdr);
		return 1;
	}
	/* C[We[u */
	memset( ImgTbl , 0 , sizeof(ImgTbl) );
	/* BMPt@Cwb_ǂݏo(62oCgŒ) */
	if ( fread( ImgTbl , 1 , 62 , SrcFD ) != 62 )
		goto bmp_read_error;

	/* BMPwb_ */
	if ( (ImgTbl[0] != 'B')||(ImgTbl[1] != 'M'))
		goto bmp_read_error;
	/* BMPt@CTCY擾 */
	bfsize = Getlong(2);
	/* 摜f[^܂ł̃ItZbg擾 */
	boffset = Getlong(10);
	/* wb_̑傫 */
	bisize = Getlong(14);
	/* wb_TCY`FbN */
	if ( (( bisize != 40 )&&( bisize != 12 ))||( bisize > boffset )||( bfsize <= boffset ) )
		goto bmp_read_error;
	/* BMPp[^擾 */
	switch( bisize ){
	/* Windows`tH[}bgł */
	case 40:
		width = Getlong(18);/*  */
		height = Getlong(22);/*  */
		bitcount = Getword(28);/* F */
//		imgsize = Getlong(34);
		parret1 = Getparret(54);
		parret2 = ( (boffset-bisize-14) == 6 ) ? Getparret(57) : Getparret(58);
		break;
	/* OS2`tH[}bgł */
	case 12:
		width = (unsigned int)Getword(18);/*  */
		height = (unsigned int)Getword(20);/*  */
		bitcount = Getword(24);/* F */
//		imgsize = 0;
		parret1 = Getparret(26);
		parret2 = ( (boffset-bisize-14) == 6 ) ? Getparret(29) : Getparret(30);
		break;
	/* m̃tH[}bg̏ꍇAG[I */
	default:
		goto bmp_read_error;
	}
#if 0
	printf("bfsize  = %d\n",bfsize );
	printf("boffset = %d\n",boffset );
	printf("bisize  = %d\n",bisize );
	printf("width   = %d\n",width );
	printf("height  = %d\n",height );
	printf("bitcount= %d\n",bitcount );
	printf("imgsize = %d\n",imgsize );
	printf("parret1 = %d\n",parret1 );
	printf("parret2 = %d\n",parret2 );
#else
	printf("Pixel Size = %d x %d\nColor = %d\n",width , height ,bitcount );
#endif
	/* mN摜ł */
	if ( bitcount != 1 )
		goto bmp_read_error;

	/* obt@TCY쐬 */
	ImgSize = bfsize - boffset;
	/* obt@TCY */
/*	if ( BuffSize != (width*height/8) ) */

	/* 𑜓x̃f[^Mp */
	BuffSize = width * height / 8;

	/* obt@TCY`FbN */
	if ( BuffSize > ( 65536 - StartAdr )){
		/* ǂݏoTCYI[o[ */
		printf("Buffer over flow.(%u)\n", StartAdr + BuffSize );
		return 1;
	}
	/* ǂݏoe[umۂ */
	if ( !(ImageTbl = malloc( (size_t)ImgSize ))){
		printf("Read Buffer Not Allocated.\n");
		return 1;
	}
	/* ǂݏoe[u */
	memset( ImageTbl , 0xff , (size_t)ImgSize );
	/* Bitmapf[^ǂݏo */
	if ( fseek( SrcFD , boffset , SEEK_SET ) )
		goto bmp_read_error;
	if ( fread( ImageTbl , 1 , (size_t)ImgSize , SrcFD ) != ImgSize )
		goto bmp_read_error;

	/* o̓obt@mۂ */
	if ( !(OutBuf = malloc( (size_t)BuffSize ))){
		printf("Output Buffer Not Allocated.\n");
		/* ǂݏoobt@J */
		free( ImageTbl );
		return 1;
	}
	/* obt@ */
	memset( OutBuf, 0 , (size_t)BuffSize );

	/* width␳ */
	width2 = ( width & 0x1f ) ? (width+32)/32*32 : width;

	/* BMP --> oCiϊ */
	for ( x = 0 ; x < width ; x++ ){
		for ( y = 0 ; y < height ; y++ ){
			/* 𔻒肷 */
			if (parret1 < parret2){
				/* if point(x,y) = 0 */
				if ( !(ImageTbl[(height-y-1)*(width2/8)+(x/8)]&((unsigned char)(0x80>>(x&7)))) )
					/* then pset(x,y) */
					OutBuf[x+((y/8)*width)] |= (unsigned char)(0x01<<(y&7));
			}
			else{
				/* if point(x,y) = 1 */
				if ( (ImageTbl[(height-y-1)*(width2/8)+(x/8)]&((unsigned char)(0x80>>(x&7)))) )
					/* then pset(x,y) */
					OutBuf[x+((y/8)*width)] |= (unsigned char)(0x01<<(y&7));
			}
		}
	}
#if FORDOS
	/* e|t@C */
	if ( fwrite( OutBuf , (size_t)BuffSize , (size_t)1 , TmpFD ) != 1 ){
		printf("Temp File write error.\n");
		return 1;
	}
#endif
	/* IAhXZbg */
	EndAdr = StartAdr + BuffSize - 1;
	OutCnt = BuffSize;
	/* ǂݏoobt@J */
	free( ImageTbl );
	return NORM;

bmp_read_error:
	/* Illigal data file */
	printf("Illigal bitmap data file.\n");
	/* ǂݏoobt@J */
	if (ImageTbl) free( ImageTbl );
	return 1;
}

/**********************************************************************/
/*   ReadHex : Read Intel HEX file                                    */
/*                                                                    */
/*       : 8bit INTEL HEXtH[}bg̃t@COutBufobt@ */
/*             ǂݏo                                               */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int ReadIhx( void )
{
char Work[MAXLINE+2];/* sf[^擾p[N */
char out[8];
unsigned int sadr,eadr,cmd;
unsigned int adr,BuffSize;	/* o̓obt@TCY */
unsigned int data,sum,chksum;
int rc,ac;
int n,len;

	/* AhX擾 */
	if ( AdrSet ){
		/* sAhXݒ */
		ExecAdr = (unsigned int)Adrs[0];
	}
	/* ϐ */
	OutCnt = 0;
	ac = 0;
	sadr=0xffff;
	eadr=0;

	ReadIhx_top:
	/* obt@ */
	memset( out , 0 , sizeof(out) );
	rc = 0;
	/* 1pX AhXXLs */
	while( !rc ){
		/* s[Nobt@ */
		memset( Work , 0 , MAXLINE );
		memset( oprwk , 0 , MAXLINE );
		/* HEXt@CPso */
		rc = GetLine2( SrcFD , Work );
		if (!Work[0]) continue;
		
		/* X^[gR[hꍇtH[}bgG[ */
		if (Work[0]!=':'){
			return 1;
		}
		/* TCYo */
		memcpy(oprwk , &Work[1] ,2 );
#if FORDOS
		if ( sscanf( oprwk , "%LX" , &len ) == EOF ){
#else
		if ( sscanf( oprwk , "%X" , &len ) == EOF ){
#endif
			printf("%s\n" , Work );
			printf("Illigal data\n");
			return 1;
		}
		/* R[h^Cvo */
		memcpy(oprwk , &Work[7] ,2 );
#if FORDOS
		if ( sscanf( oprwk , "%LX" , &cmd ) == EOF ){
#else
		if ( sscanf( oprwk , "%X" , &cmd ) == EOF ){
#endif
			printf("%s\n" , Work );
			printf("Illigal type\n");
			return 1;
		}
		/* EOF܂͊g^CvȂI */
		if (cmd >= 1){
			rc = 1;
			continue;
		}
		/* AhXo */
		memcpy(oprwk , &Work[3] ,4 );
#if FORDOS
		if ( sscanf( oprwk , "%LX" , &adr ) == EOF ){
#else
		if ( sscanf( oprwk , "%X" , &adr ) == EOF ){
#endif
			printf("%s\n" , Work );
			printf("Illigal address\n");
			return 1;
		}
		/* 񃋁[vł */
		if ( !ac ){
			/* 菬lJnAhX(sadr)ɂ */
			if( sadr > adr )
				sadr = adr;
			/* ŏIAhXXV */
			if( eadr < (adr+len-1) )
				eadr = adr + len - 1;
			
			continue;
		}
		else{
			sum = len + (adr>>8) + (adr&0xff);
			memset( oprwk , 0 , MAXLINE );
			/* HEX --> oCiϊ */
			for ( n = 0 ; n < len ; n++ ){
				/* f[^o */
				memcpy(out , &Work[(n*2)+9] ,2 );
				if ( sscanf( out , "%X" , &data ) == EOF ){
					printf("%s" , Work );
					printf("Illigal data\n");
					return 1;
				}
				/* f[^i[ */
				OutBuf[(adr-sadr)+n] = (char)data;
				sum += data;
			}
			/* `FbNTo */
			memcpy(out , &Work[(n*2)+9] ,2 );
			if ( sscanf( out , "%X" , &chksum ) == EOF ){
				printf("%s" , Work );
				printf("Illigal data\n");
				return 1;
			}
			/* `FbNT */
			sum &= 0xff;
			sum = (0x100 - sum) & 0xff;
			if ( sum != chksum ){
				printf( "%s\n" , Work );
				printf("Sum Error. %d %x %x\n",len,sum,chksum );
				return 1;
			}
		}
	}
	/* o^ł */
	if ( !ac ){
		/* g^CvȂG[I */
		if ( cmd > 1 ){
			printf("%s\n" , Work );
			printf("Illigal Type = %02x\n",cmd);
			return 1;
		}
		/* AhXlُ */
		if ( eadr > 65535 ){
			printf("%s\n" , Work );
			printf("Illigal Address\n");
			return 1;
		}
		/* AhXo^ */
		StartAdr = sadr;
		EndAdr = eadr;
		OutCnt = eadr-sadr + 1;
		/* o̓obt@mۂ */
		BuffSize = EndAdr - StartAdr + 2;
		if ( !(OutBuf = malloc( (size_t)BuffSize ))){
			printf("Output Buffer Not Allocated.\n");
			return 1;
		}
		/* obt@ */
		memset( OutBuf, 0 , (size_t)BuffSize );

		/* t@C擪ɃV[Nʒu߂ */
		if (fseek( SrcFD , 0 , SEEK_SET )){
			printf("File seek error.\n");
			return 1;
		}
		/* 2ڂ̃[v */
		ac++;
		goto ReadIhx_top;
	}
	/* IAhXZbg */
	return NORM;
}

/**********************************************************************/
/*   DisAsmProcess : Disassembler Process Main Routine                */
/*                                                                    */
/*       : tAZu                                       */
/*       : \[Xt@C                                       */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int DisAsmProcess( char * File )
{
int rc;
unsigned int i;
unsigned int CurAdr;
LBL *Label;
LBL *Labelwk;
#if _Support_SA
SATBL * AreaTable;
SATBL * AreaWk;
#endif
FILE	*TmpLstFD;	/* TEMPXgt@CfBXNv^ */
int size;

	i = 0;
	/* ݒ/\[Xt@Cǂݍ/ϊ/Xgt@C쐬 */
	if( InitDisAsm( File ) != NORM ) goto asm_end;

	/* CASEp ݒl */
	OpCase_K = 0;
	OpCase2Count = 0;

	/* sJnAhXo^ */
	if ( ExecAdr ) SetLabel( "START" , (unsigned int)ExecAdr );

	/* tAZuJnAhXZbg */
	AsmAdr = (!StartFlag || !ExecAdr ||(StartAdr==ExecAdr) ) ? StartAdr : ExecAdr;
	OutCnt = (!StartFlag || !ExecAdr ||(StartAdr==ExecAdr) ) ? 0 : (ExecAdr-StartAdr);
	/* JR/JP/CALxo^擪AhXZbg */
	LblAdr = ExecAdr ? ExecAdr : EndAdr;
	/* xo^vZbg */
	LblEnt = (!StartFlag || !ExecAdr ||(StartAdr==ExecAdr) ) ? 1 : 0;
#if FORDOS
	/* e|t@COPEN */
	if ( ( TmpFD = fopen( TmpName ,"rb" ) ) <= 0 ){
		printf("Temp File not crated.\n");
		return 1;
	}
#endif
	while(1){
		/* tAZuJnʒuZbg */
		CurAdr = OutCnt;
		/* PpXڃxe[u쐬 */
		pass = 0;
		rc = 0;
		while( !rc ){
			/* SoCgtAZu */
			rc = DisAsmCode();
		}
		/* PpXI */
		printf( " PASS %d END \n" , ++i );

		/* AZuJnAhXăZbg */
		AsmAdr = (!StartFlag || !ExecAdr||(StartAdr==ExecAdr)) ? StartAdr : LblAdr;
		OutCnt = (!StartFlag || !ExecAdr||(StartAdr==ExecAdr)) ? 0 : (LblAdr-StartAdr);
		/* ÕpXƓJnAhXƂȂI */
		if ( CurAdr == OutCnt ){
			/* xGgȂI */
			if ( LblEnt ) break;
			/* xo^ */
			LblEnt = 1;
		}
	}
	/* R[htXgo */
	if ( !NoCode ){
		/* Xgt@COPEN */
		if ( ( LstFD = fopen( LstFile ,"w" ) ) <= 0 ){
			printf("File Create Error.\n");
#if FORDOS
			/* e|t@CN[Y */
			fclose(TmpFD);
#endif
			goto asm_end;
		}
		/* Xgo͊Jn */
		fprintf( LstFD , "%s%s - ",name,rev );
		fprintf( LstFD ,"DISASSEMBLY LIST OF [%s]\n", SrcFile );
	}
	else{
		/* Xgt@COPEN */
		if ( ( LstFD = fopen( NcTmp ,"w" ) ) <= 0 ){
			printf("File Create Error.\n");
#if FORDOS
			/* e|t@CN[Y */
			fclose(TmpFD);
#endif
			goto asm_end;
		}
	}

	/* f[^o */
	if ( OutCnt ){
#if _Support_SA
		PrintArea(  0 , OutCnt-1 );
#else
		PrintData(  0 , OutCnt-1 );
#endif
	}
	/* ŏIpXBxAhX𔽉fAXgo͂ */
	rc = 0;
	pass++;
	while( !rc ){
		rc = DisAsmCode();
#if _Support_SA
		/* GAw肠 */
		if(AreaFlag){
			/* GAo͂ */
			PrintArea(OutCnt-OutTbl.byte,OutCnt-1);
		}
		else
#endif
		/* /DIvVLAC~fBGCg߃^Cv̉͂s */
		if( DataFlag && ((int)OutTbl.code[7] != OP_NUL) ){
			switch((int)OutTbl.code[0]){
			case 0xdd:
			case 0xed:
			case 0xfd:
				/* 2byteڂ */
				i = 2;
				break;
			default:
				i = 1;
				break;
			}
			/* YʒuɃx */
			if ( !GetLabel( oprwk, OutTbl.adr + i ) ){
#if _Support_SA
			/* GAo͂ */
			PrintArea( OutCnt-OutTbl.byte,OutCnt-1 );
#else
			PrintData( OutCnt-OutTbl.byte,OutCnt-1 );
#endif
			}
			else{
				/* Xgt@Co */
				PrintList();
			}
		}
		else
			/* Xgt@Co */
			PrintList();
	}
	/* tAZuI */
	printf( " PASS %d END\n" , ++i );
	printf("DISASSEMBLY COMPLETE\n");
	if( !NoCode )
		fprintf(LstFD,"\nDISASSEMBLY COMPLETE\n");

	/* xe[uo͂ */
	if ( LabelCnt ){
		/* wb_o */
		if( !NoCode ){
			/* wb_o */
			fprintf( LstFD ,"\n%s%s - ",name,rev );
			fprintf( LstFD ,"MAP LIST OF [%s]\n", SrcFile );
			fprintf( LstFD ," LABEL           : ADDRESS(hex)    LABEL           : ADDRESS(hex)\n" );
			fprintf( LstFD ,"------------------------------------------------------------------\n" );
			Label = LabelTbl; i = 0;
			while ( Label ){
				if (!(i&1))	fprintf( LstFD ," %-16s:   %04Xh        " , Label->name , Label->adr );
				else fprintf( LstFD ," %-16s:   %04Xh\n" , Label->name , Label->adr );
				Label = Label->np;
				i++;
			}
		if (i&1) fprintf( LstFD ,"\n");
		}
	}
	/* AZuo */
	if( !NoCode ){
		fprintf( LstFD ,"\n START ADDRESS   = %04Xh\n", StartAdr );
		fprintf( LstFD ," END ADDRESS     = %04Xh\n", EndAdr );
		fprintf( LstFD ," EXECUTE ADDRESS = %04Xh\n", ExecAdr );
	}

	/* R[ho͂ȂꍇAORG/START߂t */
	if ( NoCode ){
		/* e|Xgt@CN[Y */
		fclose(LstFD);
		
		/* Xgt@COPEN */
		if ( ( LstFD = fopen( LstFile ,"w" ) ) <= 0 ){
			printf("File Create Error.\n");
#if FORDOS
			/* e|t@CN[Y */
			fclose(TmpFD);
#endif
			goto asm_end;
		}
		/* wb_o */
		fprintf( LstFD ,"\n;%s%s - ",name,rev );
		fprintf( LstFD ,"DISASSEMBLY LIST OF [%s]\n\n", SrcFile );
		/* V{xo^ */
		if ( LabelCnt ){
			Label = LabelTbl;
			while ( Label ){
				/* QƂAtAZu͈͓Œ`ꂽx͏o͂Ȃ */
				if ((Label->flag)&&((Label->adr<StartAdr)||(Label->adr>EndAdr))){
					fprintf( LstFD ,"%s\tEQU\t$%04X\t;%s\n" , Label->name , Label->adr , Label->comment );
				}
				Label = Label->np;
			}
		}
		/* R[hJnAhXZbg */
		fprintf( LstFD , "\nORG	$%04X\n;\n" , StartAdr );
		
		/* sJnAhXo^ */
		if ( ExecAdr ) fprintf( LstFD , "START	START\n;\n" );
		/* e|Xgt@COPEN */
		if ( ( TmpLstFD = fopen( NcTmp ,"r" ) ) <= 0 ){
			printf("File Create Error.\n");
#if FORDOS
			/* e|t@CN[Y */
			fclose(TmpFD);
#endif
			goto asm_end;
		}
		/* e|Xgt@CAXgt@CփRs[ */
		while( size = fread(oprwk, (size_t)1, sizeof(oprwk),TmpLstFD) ){
			if (fwrite(oprwk, 1, (size_t)size, LstFD ) != (size_t)size){
				printf("List File Write Error.\n");
				break;
			}
			/* ŏIubNǏoIH */
			if ( size != sizeof(oprwk) )
				break;
		}
		/* e|Xgt@CN[Y */
		fclose(TmpLstFD);
		/* e|t@C폜 */
		remove( NcTmp );
	}

	/* Xgt@CN[Y */
	fclose(LstFD);
#if FORDOS
	/* e|t@CN[Y */
	fclose(TmpFD);
#endif
asm_end:
#if _Support_SA
	/* SÄe[u */
	AreaTable = AreaTbl;
	while ( AreaTable ){
		AreaWk = AreaTable->np;
		free( AreaTable );
		AreaTable = AreaWk;
	}
#endif /* _Support_SA */
	/* xe[u */
	Label = LabelTbl;
	while ( Label ){
		Labelwk = Label->np;
		free( Label );
		Label = Labelwk;
	}
	/* o̓obt@ */
	if ( OutBuf ) free( OutBuf );
#if FORDOS
	/* e|t@C폜 */
	remove( TmpName );
#endif
	return rc;
}

/**********************************************************************/
/*   AsmLine : Disassembler Process ( max 4 byte )                    */
/*                                                                    */
/*       : őSoCgtAZu                       */
/*       : Ȃ                                                   */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int DisAsmCode( void )
{
	char lblwk[MAXLEN];
	unsigned char c[4];		/* ߃fR[hobt@         */
	int n;					/* ߃oCg                 */
	int opr;
	unsigned int adr;		/* Jumpxo^pAhX     */
	int idx;				/* e[uCfbNX         */
	unsigned char code,kind;
	unsigned int flag;
#if _Support_SA
	SATBL Tbl;			/* SA߃e[uGg       */
#endif /* _Support_SA */

	opr = 0;
	/* R[hϊobt@ */
	memset( &OutTbl.adr,0, sizeof(OUTTBL));
	memset( &c[0] ,0xff,4);

	/* ݂̃AZuAhXo^ */
	OutTbl.adr = AsmAdr;
#if _Support_SA
	AreaFlag = 0;
	/* ݂̃AhXSA߂Ń[N̈o^ς݁H */
	if( !GetArea( OutTbl.adr, &Tbl ) ){
		n  = Tbl.byte;
		/* [N̈擪ƈvȂꍇ */
		if ( Tbl.adr < OutTbl.adr ){
			/* [NTCY␳ */
			n -= (OutTbl.adr - Tbl.adr);
		}
		/* [N̈ŏIIhXI[o[ꍇ */
		else if ( ( OutTbl.adr + Tbl.byte -1) > EndAdr){
			/* [NTCY␳ */
			n = EndAdr - OutTbl.adr + 1;
		}
		AreaFlag = 1;
		goto DisAsmCodeEnd;
	}
#endif /* _Support_SA */
	
#if FORDOS
	/* e|t@Co */
	fseek( TmpFD, OutCnt, SEEK_SET );
	/* SoCgo */
	fread( OutTbl.code , (size_t)((OutCnt<(BuffSize-4)) ? 4 : (BuffSize-OutCnt)) , (size_t)1 , TmpFD );
	memcpy( &c[0] , &OutTbl.code , (size_t)((OutCnt<(BuffSize-4)) ? 4 : (BuffSize-OutCnt)) );
#else
	/* SoCgo */
	memcpy( OutTbl.code , &OutBuf[OutCnt] , (size_t)((OutCnt<(BuffSize-4)) ? 4 : (BuffSize-OutCnt)) );
	memcpy( &c[0] , &OutBuf[OutCnt] , (size_t)((OutCnt<(BuffSize-4)) ? 4 : (BuffSize-OutCnt)) );
#endif
#if 1
	/* f[^o */
	if ( !c[0]&&!c[1]&&!c[2] ){
//		BtmFlag = 0;
		/* f[^̓[h́AR[hIoɂďI */
		if ( DataFlag ) return 1;
	}
#endif
	/* xw肠(2pX) */
	if (pass)
		/* ݂̃AhXx̂ɕϊ */
		GetLabel( OutTbl.label, (unsigned int)AsmAdr );

	/* ߎʎ擾 */
	code = c[0];
	kind = CASE2_OP;
	/* CASE2Iyhł͂Ȃ */
	if ( !OpCase2Count ){
		/* LP߂ł */
		if ( code >= 0x80 && code <= 0xbf ){
			code = 0x80;
		}
		/* CAL߂ł */
		if ( code >= 0xE0 ){
			code = 0xE0;
		}
		/* ߃e[u */
		for ( idx = 0, kind = OP_UNKNOWN, n = 0 ; idx < MAXOP ; idx++ ){
			/* Y߂ */
			if ( codetbl[idx].code == code ){
				/* ߃oCgo */
				n = codetbl[idx].byte;
				/* ߎʎo */
				kind = codetbl[idx].kind;
				/* jjbN ݒ */
				sprintf( OutTbl.mn ,"%s" , codetbl[idx].name );
				break;
			}
		}
	}
	/* ߃R[hʂɂ镪 */
	switch( kind ){
	/* 1oCg */
	case OP_NUL:
		/* sRgo */
		if(Comment)
			sprintf( OutTbl.comment ,"%s" , codetbl[idx].comment );
		break;
	/* 2oCg  XX n */
	case OP_8:
		/* LIQ/LIP߂̏ꍇ */
		if( ( code == 0x12 )||( code == 0x13 )){
			/* LPߑ̓xϊ\Ƃ */
			adr = (unsigned int)c[1];
			goto in_ram_lbl;
		}
		sprintf( &OutTbl.opr[opr++][0] ,"$%02X" , c[1] );
		/* sRgo */
		if(Comment)
			sprintf( OutTbl.comment ,codetbl[idx].comment,(int)c[1] );
		break;
	/* 3oCg  XX mn */
	case OP_16:
		switch( code ){
		case 0x10:
			flag = 2;
			break;
		case 0x78:
			flag = 1;
			break;
		default:
			flag = 0;
			break;
		}
		adr = (((unsigned int)(c[1])<<8)|(unsigned int)c[2]);
		SetAddressLabel( opr , flag , adr );
		/* sRgo */
		if(Comment)
		sprintf( OutTbl.comment ,codetbl[idx].comment,adr );
		break;
	/* ΃Wv { */
	case OP_JRP:
		adr = AsmAdr + (unsigned int)( c[1] ) + 1;
		SetAddressLabel( opr , 0 , adr );
		/* sRgo */
		if(Comment)
		sprintf( OutTbl.comment ,codetbl[idx].comment,adr );
		break;
	/* ΃Wv | */
	case OP_JRM:
		adr = AsmAdr - (unsigned int)( c[1] ) +1;
		SetAddressLabel( opr , 0 , adr );
		/* sRgo */
		if(Comment)
		sprintf( OutTbl.comment ,codetbl[idx].comment,adr );
		break;
	/* LP */
	case OP_LP:
		/* AhX擾 */
		adr = (unsigned int)(c[0]&0x3f);
in_ram_lbl:
		/* xo^ */
		if ( !GetLabel( lblwk , adr ) ){
			/* x\Lɒu */
			sprintf( &OutTbl.opr[opr++][0] ,"%s",lblwk );
			/* xRg擾 */
			GetLabelCmt(lblwk , OutTbl.comment );
		}
		else{
			/* lo */
			sprintf( &OutTbl.opr[opr++][0] ,"$%02X",adr );
		}
		/* sRgo */
		if(Comment)
			sprintf( OutTbl.comment ,codetbl[idx].comment,adr );
		break;
	/* CAL */
	case OP_CAL:
		adr = (((unsigned int)(c[0]&0x1f)<<8)|(unsigned int)c[1]);
		SetAddressLabel( opr , 1 , adr );
		/* Rgo */
		if(Comment)
			sprintf( OutTbl.comment ,codetbl[idx].comment,adr );
		break;
	/* CASE1 */
	case OP_CASE1:
		/* CASE2p KZbg */
		OpCase_K = c[1];
		sprintf( &OutTbl.opr[opr++][0] ,"$%02X,",c[1] );
		adr = ((((unsigned int)c[2])<<8)|(unsigned int)c[3]);
		SetAddressLabel( opr , 0 , adr );
		/* sRgo */
		if(Comment)
			sprintf( OutTbl.comment ,codetbl[idx].comment,(int)c[1],adr );
		break;
	/* CASE2 */
	case OP_CASE2:
		OpCase2Count = (unsigned char)(OpCase_K+1);
		/* sRgo */
		if(Comment)
			sprintf( OutTbl.comment ,"%s" , codetbl[idx].comment );
		break;
	/* CASE2IyR[h */
	case CASE2_OP:
		if (--OpCase2Count){
			n = 3;
			/* DL߂Ƃ */
			sprintf( OutTbl.mn ,"DL");
			sprintf( &OutTbl.opr[opr++][0] ,"$%02X,",c[0] );
			/* sRg쐬 */
			if(Comment)
				sprintf( OutTbl.comment,"IF A=%02X JUMP $%02X%02X",(int)c[0] ,(int)c[1],(int)c[2] );
			adr = (((unsigned int)c[opr])<<8)|(unsigned int)c[opr+1];
		}
		else{
			n = 2;
			/* DW߂Ƃ */
			sprintf( OutTbl.mn ,"DW");
			/* sRg쐬 */
			if(Comment)
				sprintf( OutTbl.comment,"ELSE JUMP $%02X%02X",(int)c[0] ,(int)c[1] );
			/* KWX^lNA */
			OpCase_K = 0;
			adr = (((unsigned int)c[0])<<8)|(unsigned int)c[1];
		}
		/* AhXxo^ */
		SetAddressLabel( opr , 0 , adr );
		break;
	/* sR[h */
	default:
		n = 1;
		/* jjbN ݒ */
		sprintf( OutTbl.mn ,"%s", "DB" );
		sprintf( &OutTbl.opr[opr++][0] ,"$%02X" , c[0] );
		break;
	}
DisAsmCodeEnd:
	/* ߃oCgi[ */
	OutTbl.byte = n;
	/* /DIvV͖߃^Cvi[ *//* ΃Wv߂͏O */
	if( ( DataFlag )&&( kind != OP_JRP )){
		OutTbl.code[7] = (unsigned char)(kind & 0xf);
	}
	/* ߃fR[hAhXXV */
	OutCnt += n;
	AsmAdr += n;
	/* tAZuI */
	if ( AsmAdr > EndAdr ) return 1;
	return 0;
}
#if _Support_SA
/**********************************************************************/
/*   SetAreaTbl : Entry Area table                                    */
/*                                                                    */
/*       : SA^ߗp[NGAo^                           */
/*       : JnAhX(0`65535)A[NTCY(0`65535)         */
/*           : (0:DBA1:A2:bin)                            */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int SetAreaTbl( unsigned char type , unsigned int adr , unsigned int size , unsigned int div )
{
SATBL * AreaTable;
SATBL * AreaWk;
//	printf("SetAreaTbl() type=%d adr=%04xh size=%d div=%d\n",type,adr,size,div);
	/* 擪|C^Zbg */
	AreaTable = AreaTbl;
	while( AreaTable ){
		/* YAhX */
		if (( AreaTable->adr <= adr )
		 &&(( AreaTable->adr + AreaTable->byte ) > adr )){
			/* ɓAhXo^ĂꍇAG[I */
			return DUPADR;
		}
		/* ŏISAe[uAhXB */
		if ( !AreaTable->np ) break;
		/* SÄe[u|C^XV */
		AreaTable = AreaTable->np;
	}
	/* SÄe[um */
	if ( AreaWk = malloc( sizeof(SATBL) )){
		memset( AreaWk , 0 , sizeof(SATBL) );
	}
	else return SANOALOC;

	/* o^Ȃ擪|C^ɓo^ */
	if ( !AreaTbl ) AreaTbl = AreaWk;
	/* mۂ|C^|C^Ƃēo^ */
	else AreaTable->np = AreaWk;

	/* SÄ|C^XV */
	AreaTable = AreaWk;
	/* 擪AhXxe[uɓo^ */
	AreaTable->adr = adr;
	/* SÄTCYo^ */
	AreaTable->byte = size;
	/* SÄʂo^ */
	AreaTable->type = type;
	/* ̈敝^o^ */
	AreaTable->div = div;
	/* SAo^XV */
	AreaCnt++;

	return NORM;
}

/**********************************************************************/
/*   GetArea : Get Work Area                                          */
/*                                                                    */
/*       : AhXSAo^ꂽ[N               */
/*       : AhXl(0`65535)                                   */
/*   o    : SAo^|C^i0:YȂA0ȊO:Yj       */
/*                                                                    */
/**********************************************************************/
int GetArea( unsigned int adr ,SATBL *Tbl)
{
SATBL * AreaTable;
	/* 擪|C^Zbg */
	AreaTable = AreaTbl;
	while( AreaTable ){
		/* wAhXɊYSÄ𔭌 */
		if (( AreaTable->adr <= adr )
		 &&(( AreaTable->adr + AreaTable->byte ) > adr )){
			/* SÄe[u|C^Ԃ */
		 	memcpy(Tbl,AreaTable,sizeof(SATBL));
//		 	printf("adr=%04x byte=%d",AreaTable->adr,AreaTable->byte);
			return 0;
		}
		/* SÄ|C^XV */
		AreaTable = AreaTable->np;
	}
	/* YȂԂ */
	return 1;
}
/**********************************************************************/
/*   GetAreaName : Get Area Label Name                                */
/*                                                                    */
/*       : AhXSAo^ꂽx쐬             */
/*       : x|C^Ao^AhXl                       */
/*   o    : G[i0:A1:̈GgȂj               */
/*                                                                    */
/**********************************************************************/
int GetAreaName( char * buff , unsigned int adr )
{
	SATBL Tbl;			/* SA߃e[uGg       */
	char lblwk[MAXLEN];	/* x[N */

	/* ݂̃AhXSA߂Ń[N̈o^ς݁H */
	if( !GetArea( adr, &Tbl ) ){
		/* x o */
		if ( !GetLabel( lblwk , Tbl.adr ) ){
			/* GA擪ł */
			if( adr == Tbl.adr ){
				/* x̂̂܂ܕԂ */
				strcpy( buff , lblwk  );
			}
			else{
				if((!Tbl.div)||((adr-Tbl.adr)<=(Tbl.div))){
					/* "GA擪 + n" Ԃ */
#if FORDOS
					sprintf(buff,"%s+%d",lblwk, (adr-Tbl.adr));
#else
					snprintf(buff,MAXLEN-1,"%s+%d",lblwk, (adr-Tbl.adr));
#endif
				}
				else{
					if((adr-Tbl.adr)%Tbl.div){
						/* "GA擪 +div*n+m" Ԃ */
#if FORDOS
						sprintf(buff,"%s+%d*%d+%d",lblwk,Tbl.div,(adr-Tbl.adr)/Tbl.div, (adr-Tbl.adr)%Tbl.div );
#else
						snprintf(buff,MAXLEN-1,"%s+%d*%d+%d",lblwk,Tbl.div,(adr-Tbl.adr)/Tbl.div, (adr-Tbl.adr)%Tbl.div );
#endif
					}
					else{
						/* "GA擪 +div*n" Ԃ */
#if FORDOS
						sprintf(buff,"%s+%d*%d",lblwk,Tbl.div,(adr-Tbl.adr)/Tbl.div );
#else
						snprintf(buff,MAXLEN-1,"%s+%d*%d",lblwk,Tbl.div,(adr-Tbl.adr)/Tbl.div );
#endif
					}
				}
			}
		  	/* xRg𒊏o */
			GetLabelCmt(lblwk , OutTbl.comment );
			
			/* Ÿ悠 */
			return 0;
		}
	}
	/* ŸȂ */
	return 1;
}
#endif /* _Support_SA */

/**********************************************************************/
/*   SetAddressLabel : Set Label                                      */
/*                                                                    */
/*       : AhXxo^                               */
/*       : IyhʒuiXgo͗pj                         */
/*           : o^AhXli0`0xFFFFj                            */
/*           : ʃtO(0:Wv߁A1:CALL߁A2:LIDP)     */
/*                                                                    */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
void SetAddressLabel( int opr, unsigned int flag, unsigned int adr )
{
	char lblwk[MAXLEN];
/*  Debug /s IvV̓f[^xo^قǂ̂ŃRg */
//	if ( ( flag == 2 ) && !BtmFlag ) goto GetLbl;

	/* pXł */
	if ( !pass ){
#if _Support_SA
		/* LDߎ́ASAwGÃxɕϊ(x"DAT"͏O) */
		if ( !GetAreaName(lblwk,adr)&&(flag==2)&&(memcmp(lblwk,"DAT",3)) ){
			sprintf(&OutTbl.opr[opr][0] ,"%s", lblwk );
		}
		else
#endif /* _Support_SA */
		{		/* xe[uo^ */
		SetLabelTbl( flag ,adr );
		/* jjbN쐬 */
		sprintf(&OutTbl.opr[opr][0] ,"$%04X", adr );
		}
	}
	else{
//GetLbl:
		if ( !GetLabel( lblwk , adr ) ){
			sprintf(&OutTbl.opr[opr][0] ,"%s", lblwk );
//			if (flag==2)
			{
				GetLabelCmt(lblwk , OutTbl.comment );
			}
		}
#if _Support_SA
		/* LDߎ́ASAwGÃxɕϊ */
		else if ( !GetAreaName(lblwk,adr)&&(flag==2) ){
			sprintf(&OutTbl.opr[opr][0] ,"%s", lblwk );
		}
#endif /* _Support_SA */
		else
			sprintf(&OutTbl.opr[opr][0] ,"$%04X",adr );
	}
}

/**********************************************************************/
/*   ChgCode : Change String code  (abc...->ABC...)                   */
/*                                                                    */
/*       : At@xbg啶ɕϊ                 */
/*       : Iyh|C^Ao̓obt@|C^               */
/*   o    : ϊ                                           */
/*                                                                    */
/**********************************************************************/
int ChgCode( char * dst , char * src )
{
int	i,len;
	/* o͐敶NA */
	dst[0] = 0;
	if (! src ) return 0;
	/* Iyh񒷃`FbN */
	len = strlen( src );
	if( !len ) return 0;
	/* ϊ */
	for( i = 0 ; i < len ; i++ ){
		/* `FbN */
		if( (src[i] >= 'a')&&(src[i] <= 'z') ){
			/* At@xbgȂ啶ɕϊ */
			dst[i] = (char)( src[i] - (char)0x20 );
		}
		else{
			/* ̂܂܃Rs[ */
			dst[i] = src[i];
		}
	}
	/* ŏINull} */
	dst[i] = 0;
	return len;
}
/**********************************************************************/
/*   SetLabelTbl : Entry Label table                                  */
/*                                                                    */
/*       : xe[uɃxƃAhXo^             */
/*       : x|C^Ao^AhXli0:ȊOj               */
/*           : ʃtO(0:Wv߁A1:CALL߁A2:LIDP)     */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int SetLabelTbl( unsigned int flag , unsigned int adr )
{
LBL * Label;
LBL * Labelwk;
#if _Support_SA
SATBL Tbl;		/* SA߃e[uGg       */
#endif /* _Support_SA */
static int empt = 0;
	/* tAZu͈͓ł */
	if ( (StartAdr > adr)||(EndAdr < adr) ) return LBNOALOC;

	/* R[h擪AhXXV */
	if ( flag != 2 ){
#if _Support_SA
		/* xAhXSA߂Ń[N̈o^ς݁H */
		if( !GetArea( adr, &Tbl ) ){
			/* GA`͋tAZu͈͓łH */
			if ((Tbl.adr + Tbl.byte-1) <= EndAdr){
				/* AhX␳ */
				LblAdr = Tbl.adr + Tbl.byte-1;
			}
		}
		else{
			LblAdr = (LblAdr > adr) ? adr : LblAdr;
		}
#else
		LblAdr = (LblAdr > adr) ? adr : LblAdr;
#endif /* _Support_SA */
	}

	/* xo^vȂ */
	if ( !LblEnt ) return LBNOALOC;

	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* YxAhX */
		if ( Label->adr == (unsigned int)adr ){
			/* CAL߂ɂ镪̏ꍇAxMDLƂ */
			if ( (flag==1) && !memcmp( Label->name ,"LBL", 3 ) )
				memcpy( Label->name ,"MDL", 3 );
			/* ɓAhXo^ĂꍇAG[I */
			return DUPLBL;
		}
		/* ŏIxAhXB */
		if ( !Label->np ) break;
		/* x|C^XV */
		Label = Label->np;
	}
	/* xe[um */
	if ( Labelwk = malloc( sizeof(LBL) )){
		memset( Labelwk , 0 , sizeof(LBL) );
	}
	else{
		/* słȏo^łȂ */
		if (!empt){
			printf("Warning: No more labels can be added.\n");
			empt = 1;
		}
		return LBNOALOC;
	};

	/* o^Ȃ擪|C^ɓo^ */
	if ( !LabelTbl ) LabelTbl = Labelwk;
	/* mۂ|C^|C^Ƃēo^ */
	else Label->np = Labelwk;

	/* x|C^XV */
	Label = Labelwk;
	/* x̂e[uɓo^ */
	switch(flag){
	case 1:
#if FORDOS
		sprintf( Label->name ,"MDL%04X", (unsigned int)adr );
#else
		sprintf( Label->name ,"MDL%04X", adr );
#endif
		break;
	case 2:
#if FORDOS
		sprintf( Label->name ,"DAT%04X", (unsigned int)adr );
#else
		sprintf( Label->name ,"DAT%04X", adr );
#endif
		break;
	default:
#if FORDOS
		sprintf( Label->name ,"LBL%04X", (unsigned int)adr );
#else
		sprintf( Label->name ,"LBL%04X", adr );
#endif
		break;
	}
	/* xo^XV */
	LabelCnt++;
	/* ݂̃AZuAhXxe[uɓo^ */
	Label->adr = adr;

	return NORM;
}
/**********************************************************************/
/*   SetLabel : Entry Label table                                     */
/*                                                                    */
/*       : xe[uɃxƃAhXo^             */
/*       : x|C^Ao^AhXli0:ȊOj               */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int SetLabelEntry( OUTTBL * Tbl , unsigned int adr )
{
LBL * Label;
LBL * Labelwk;
int cnt = 0;

	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* Yx */
		if (!strcmp( Label->name , Tbl->label )){
			/* ɓ̂gĂꍇAG[I */
			return DUPLBL;
		}
		/* ŏIxAhXB */
		if ( !Label->np ) break;
		/* x|C^XV */
		Label = Label->np;
	}
	/* xe[um(Rg͉) */
	if ( Labelwk = malloc( sizeof(LBL) + strlen(Tbl->comment) ) ){
		memset( Labelwk , 0 , sizeof(LBL) + strlen(Tbl->comment) );
	}
	else return LBNOALOC;

	/* o^Ȃ擪|C^ɓo^ */
	if ( !LabelTbl ) LabelTbl = Labelwk;
	/* mۂ|C^|C^Ƃēo^ */
	else Label->np = Labelwk;

	/* x|C^XV */
	Label = Labelwk;
	/* x̂e[uɓo^ */
	sprintf( Label->name , "%s" , Tbl->label );
	/* Rgo^ */
	sprintf( Label->comment , "%s" , Tbl->comment );
	/* ݂̃AZuAhXxe[uɓo^ */
	Label->adr = adr;

	/**************************************/
	/* l̏ꍇWarning\ */
	/**************************************/
//	if ( NoCode == 2 )
	{
		/* 擪x|C^Zbg */
		Label = LabelTbl;
		while( Label ){
			/* "MODEL"`͏O */
			if ( strcmp( Label->name , "MODEL" ) ){
				/* YxƓlH */
				if ( Label->adr == adr ){
					/* lxJEg */
					cnt ++;
				}
			}
			/* ŏIxAhXB */
			if ( !Label->np ) break;
			/* x|C^XV */
			Label = Label->np;
		}
		/* loAig͊܂܂Ȃj */
		if ( cnt >= 2 ){
			return SAMEIMM;
		}
	}
	return NORM;
}
/**********************************************************************/
/*   SetLabel : Entry Label table                                     */
/*                                                                    */
/*       : xe[uɃxƃAhXo^             */
/*       : x|C^Ao^AhXli0:ȊOj               */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int SetLabel( char * buff , unsigned int adr )
{
LBL * Label;
LBL * Labelwk;

	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* Yx */
		if (!strcmp( Label->name , buff )){
			/* ɓ̂gĂꍇAG[I */
			return DUPLBL;
		}
		/* ŏIxAhXB */
		if ( !Label->np ) break;
		/* x|C^XV */
		Label = Label->np;
	}
	/* xe[um */
	if ( Labelwk = malloc( sizeof(LBL) ) ){
		memset( Labelwk , 0 , sizeof(LBL) );
	}
	else return LBNOALOC;

	/* o^Ȃ擪|C^ɓo^ */
	if ( !LabelTbl ) LabelTbl = Labelwk;
	/* mۂ|C^|C^Ƃēo^ */
	else Label->np = Labelwk;

	/* x|C^XV */
	Label = Labelwk;
	/* x̂e[uɓo^ */
	memcpy( Label->name , buff , strlen(buff) );
	/* ݂̃AZuAhXxe[uɓo^ */
	Label->adr = adr;

	return NORM;
}

/**********************************************************************/
/*   GetLabel : Get Label                                             */
/*                                                                    */
/*       : AhX烉x                         */
/*       : x|C^Ao^AhXl                         */
/*   o    : G[i0:A0ȊO:xGgȂj       */
/*                                                                    */
/**********************************************************************/
int GetLabel( char * buff , unsigned int adr )
{
LBL * Label;
	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* Yx */
		if ( Label->adr == adr){
			/* ׃QƂ */
			Label->flag = 1;
			/* x̂Ԃ */
			strcpy( buff , Label->name );
			return NORM;
		}
		/* x|C^XV */
		Label = Label->np;
	}
	return LBLNOENT;
}

/**********************************************************************/
/*   GetLabelAdr : Get Label Address                                  */
/*                                                                    */
/*       : xAhX                         */
/*       : x|C^Ao^AhXl                         */
/*   o    : G[i0:A0ȊO:xGgȂj       */
/*                                                                    */
/**********************************************************************/
int GetLabelAdr( char * buff , unsigned int * adr )
{
LBL * Label;
	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* Yx */
		if (!strcmp( Label->name , buff )){
			/* xAhXԂ */
			*adr = Label->adr;
			return NORM;
		}
		/* x|C^XV */
		Label = Label->np;
	}
	return LBLNOENT;
}

/**********************************************************************/
/*   GetLabelPtr : Get Label Comment                                  */
/*                                                                    */
/*       : xARg̃|C^Ԃ                 */
/*       : x|C^Ao^AhXl                         */
/*   o    : 0:YRgȂA0ȊO:RgLj               */
/*                                                                    */
/**********************************************************************/
int GetLabelCmt( char * buff , char * comment )
{
LBL * Label;
	/* 擪x|C^Zbg */
	Label = LabelTbl;
	while( Label ){
		/* Yx */
		if (!strcmp( Label->name , buff )){
			/* Yx̃RgAhXԂ */
			sprintf(comment ,"%s", Label->comment);
			return NORM;
		}
		/* x|C^XV */
		Label = Label->np;
	}
	return LBLNOENT;
}
/**********************************************************************/
/*   CheckLabel : Check Label String                                  */
/*                                                                    */
/*       : x̌S`FbN                     */
/*       : Iyh|C^                                     */
/*   o    : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int CheckLabel( char * buff )
{
int	i,len;

	/* x񒷃`FbN */
	len = strlen( buff );
	if( !len || ( len > MAXLBL ) ) return OPOFLOW;
	/* 擪ł͂Ȃ */
	if( strchr( DecStr , buff[0] ) ) return ILLLBL;
	/* xps */
	for( i = 0 ; i < len ; i++ ){
		/* x`FbN */
		if( !strchr( LabelStr , buff[i] ) ) return ILLLBL;
	}
	/* I */
	return 0;
}

/**********************************************************************/
/*   GetCalcData : Get Calculate Data                                 */
/*                                                                    */
/*       : Ƃė^ꂽvZ                     */
/*       : 擪|C^Ao^AhXl                     */
/*   o    : G[i0:A0ȊO:G[j                 */
/*           : (kind)  LBLOK(̉ς)LBLNG(̖)      */
/*           : vZl(adr) LBLOK̂ݗLBȊO͕sl          */
/**********************************************************************/
int GetCalcData( char * buff , unsigned int * kind ,unsigned int * adr )
{
int rc;
unsigned int val;

	/* IyhGg */
	if ( !buff ) return ILLOPR;

	/* vZp񂠂 */
	if ( !strlen(buff) ) return ILLOPR;

	/* vZobt@ */
	CalcPtr = 0;
	memset( calcwk , 0 , sizeof(calcwk) );
	sprintf( calcwk , "%s" , buff );

	/* ̉ς݃Zbg */
	Ckind = LBLOK;

	/* vZ */
	if ( rc = CalcVal( &val ) ) return rc;

	/* 2pXڂɖ`x */
	if ( pass && (Ckind==LBLNG) ) return LBLNOENT;

	/* I */
	*adr = val;
	*kind = Ckind;
	return NORM;
}

/**********************************************************************/
/*   CalcVal : Calculate Logical                                      */
/*                                                                    */
/*       : ^ꂽrZ(D揇ʍŒ)           */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal(unsigned int * value )
{
int rc;
unsigned int val,wval;

	/* 擪̒l擾 */
	if( rc = CalcVal0( &val ) ) return rc;
	while( 1 ){
		switch( calcwk[CalcPtr] ){
		/* =  */
		case '=':
			CalcPtr ++;
			if ( calcwk[CalcPtr] == '>' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (val >= wval);
				break;
			}
			if ( calcwk[CalcPtr] == '<' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (val <= wval);
				break;
			}
			if ( rc = CalcVal0( &wval ) ) return rc;
			val = (val == wval);
			break;
		/* >  */
		case '>':
			CalcPtr ++;
			if ( calcwk[CalcPtr] == '=' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (val >= wval);
				break;
			}
			if ( calcwk[CalcPtr] == '<' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (val != wval);
				break;
			}
			if ( rc = CalcVal0( &wval ) ) return rc;
			val = (val > wval);
			break;
		/* <  */
		case '<':
			CalcPtr ++;
			if ( calcwk[CalcPtr] == '=' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (val <= wval);
				break;
			}
			if ( calcwk[CalcPtr] == '>' ){
				CalcPtr ++;
				if ( rc = CalcVal0( &wval ) ) return rc;
				val = (val != wval);
				break;
			}
			if ( rc = CalcVal0( &wval ) ) return rc;
			val = (val < wval);
			break;
		case '(':
			return CALERR;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal0 : Calculate Logical                                     */
/*                                                                    */
/*       : ^ꂽ_Z(D揇+1)             */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal0(unsigned int * value )
{
int rc;
unsigned int val,wval;

	/* 擪̒l擾 */
	if( rc = CalcValShift( &val ) ) return rc;
	while( 1 ){
		switch( calcwk[CalcPtr] ){
		/* AND */
		case '&':
			CalcPtr ++;
			if ( rc = CalcValShift( &wval ) ) return rc;
			val &= wval;
			break;
		/* OR */
		case '|':
			CalcPtr ++;
			if ( rc = CalcValShift( &wval ) ) return rc;
			val |= wval;
			break;
		/* XOR */
		case '^':
			CalcPtr ++;
			if ( rc = CalcValShift( &wval ) ) return rc;
			val ^= wval;
			break;
		case '(':
			return CALERR;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcValShift : Calculate Shift.                                  */
/*                                                                    */
/*       : ^ꂽVtgZ(D揇+2)           */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcValShift(unsigned int * value )
{
int rc;
unsigned int val,wval;

	/* 擪l擾 */
	if( rc = CalcVal1( &val ) ) return rc;
	while( 1 ) {
		/* EVtgZ */
		if ( (calcwk[CalcPtr]=='>')&&(calcwk[CalcPtr+1]=='>') ){
			CalcPtr += 2;
			if ( rc = CalcVal1( &wval ) ) return rc;
			val = val>>wval;
		}
		else if ( (calcwk[CalcPtr]=='<')&&(calcwk[CalcPtr+1]=='<') ){
			CalcPtr += 2;
			if ( rc = CalcVal1( &wval ) ) return rc;
			val = val<<wval;
		}
		else {
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal1 : Calculate Add/Sub.                                    */
/*                                                                    */
/*       : ^ꂽZ(D揇+3)               */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal1(unsigned int * value )
{
int rc;
unsigned int val,wval;

	/* 擪l擾 */
	if( rc = CalcVal2( &val ) ) return rc;
	while( 1 ) {
		switch( calcwk[CalcPtr] ){
		/* Z */
		case '+':
			CalcPtr ++;
			if ( rc = CalcVal2( &wval ) ) return rc;
			val += wval;
			break;
		/* Z */
		case '-':
			CalcPtr ++;
			if ( rc = CalcVal2( &wval ) ) return rc;
			val -= wval;
			break;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal2 : Calculate Multiple/Divide.                            */
/*                                                                    */
/*       : ^ꂽ揜Z(D揇+4)               */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal2(unsigned int * value )
{
int rc;
unsigned int val,wval;

	/* 擪l擾 */
	if( rc = CalcVal3( &val ) ) return rc;
	while( 1 ) {
		switch( calcwk[CalcPtr] ){
		/* Z */
		case '*':
			CalcPtr ++;
			if ( rc = CalcVal3( &wval ) ) return rc;
			val *= wval;
			break;
		/* Z */
		case '/':
			CalcPtr ++;
			if ( rc = CalcVal3( &wval ) ) return rc;
			/* 0ŏZ */
			if ( !wval ) return CALERR;
			val /= wval;
			break;
		/* MOD */
		case '%':
			CalcPtr ++;
			if ( rc = CalcVal3( &wval ) ) return rc;
			/* 0ŏZ */
			if ( !wval ) return CALERR;
			val %= wval;
			break;
		/* I */
		default:
			*value = val;
			return NORM;
		}
	}
}

/**********************************************************************/
/*   CalcVal3 : Calculate ()                                          */
/*                                                                    */
/*       : ʓ̉Zs(D揇ʍō)                       */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : vZl(value)                                          */
/*                                                                    */
/**********************************************************************/
int CalcVal3( unsigned int *value )
{
int rc;
unsigned int val,flag;

	flag = 0;

	/* ]]v */
	if( calcwk[CalcPtr] == '!' ){
		CalcPtr++;
		flag = 1;
	}
	/* ʓł */
	if( calcwk[CalcPtr] == '(' ) {
		CalcPtr++;
		/* ʓ̌vZ͍łD揇ʂ̒Ⴂɍs */
		if( rc = CalcVal( &val ) ) return rc;
		/* ʂĂȂB*/
		if( calcwk[CalcPtr++] != ')' ) return ILLDQUO;
	}
	else{
		/* l܂̓xł */
		if( rc = GetValue( &val ) ) return rc;
	}
	/* wɂlC */
	if ( calcwk[CalcPtr] == '.'){
		CalcPtr++;
		switch( calcwk[CalcPtr] ){
		/* ʌw */
		case 'h':
		case 'H':
			val = val >> 8;
			break;
		/* ʌw */
		case 'l':
		case 'L':
			val &= 0xff;
			break;
		/* rbg] */
		case 'n':
		case 'N':
			val = ~val;
			break;
		default:
			return ILLOPR;
		}
		CalcPtr++;
	}
	/* vZlԂ */
	*value = !flag ? val : !val;
	return NORM;
}

/**********************************************************************/
/*   GetValue : Get Data Value                                        */
/*                                                                    */
/*       : x܂͐lAlo                     */
/*       : l|C^                                           */
/*   o    : G[i0:A0ȊO:G[j                     */
/*           : 擾l(value)                                          */
/*           : x̉tO(Ckind) (LBLNG:̖)         */
/*                                                                    */
/**********************************************************************/
int GetValue(unsigned int *value ) {
unsigned int val;
int		i;
char			lblwk[MAXLINE+2];   /* vZl擾px[N   */
	/* f[^ */
	*value = 0;
	/* x/l擾pobt@ */
	memset( lblwk , 0 , sizeof(lblwk) );

	/* Zqo܂ŌJԂ */
	i = 0;
	while ( 1 ){
		/* Zq܂NulloɂďI */
		if ( !calcwk[CalcPtr] || strchr( "+-*/|^%().<>=" , calcwk[CalcPtr] ) ) break;
		/* 擪ȊO&oŏI */
		if ( calcwk[CalcPtr] == '&' && i ) break;
		/* Rs[ */
		lblwk[i++] = calcwk[CalcPtr++];
	}
	/* o͐lł */
	if ( GetData( lblwk , &val ) ){
		/* xł */
		if ( CheckLabel( lblwk ) ) return ILLLBL;
		/* xAhXo */
		if ( GetLabelAdr ( lblwk , &val ) ){
			/* x̖Ƃ */
			Ckind = LBLNG;
			val = 0;
		}
	}
	/* ߂lԂ */
	*value = val;
	return NORM;
}

/**********************************************************************/
/*   GetData : Get Immdiate Data                                      */
/*                                                                    */
/*       : 񂩂琔lf[^擾                         */
/*       : |C^Af[^|C^                         */
/*   o    : l(data)                                               */
/*           : G[i0:A0ȊO:ُj                       */
/*                                                                    */
/**********************************************************************/
int GetData( char *buff , unsigned int * data )
{
int	i,len;
unsigned int sts;
	/* Iyh񒷃`FbN */
	len = strlen( buff );
	if( !len || ( len > MAXLEN ) ) return OPOFLOW;

	/* 擪эŏI̓_uR[e[V(=Gg)ł */
	if ( ( buff[0] == 0x22 ) && ( buff[len-1] == 0x22 ) ){
		/* 񒷂RSł */
		if( len == 3 ){
			/* ʂ͎b16rbglƂ */
			*data = (unsigned int)buff[1];
			return NORM;
		}
		else{
			if( len == 4 ){
				/* ʂ͎b16rbglƂ */
				*data = ( (unsigned int)buff[2]|((unsigned int)buff[1]<<8) );
				return NORM;
			}
			else return ILLOPR;
		}
	}
	/* Qiwł */
	if ( (buff[0] == '&')&&((buff[1] == 'B')||(buff[1] == 'b')) ){
		for( i = 2 , sts = 0; i < len ; i++ ){
			/* 2iグ */
			sts *= 2;
			/* `FbN */
			switch ( buff[i] ){
			case '1':
				sts |= 0x1;
			case '0':
				break;
			default:
				return ILLOPR;
			}
		}
		/* ͈̓I[o[ł */
		if ( sts >= 65536 ) return OFLOW;
		/* I */
		*data = (unsigned int )sts;
		return NORM;
	}
	/* PUiwł */
	if ( (buff[0] == '$')||(buff[0] == '&') ){
		for( i = 1 ; i < len ; i++ ){
			/* `FbN */
			if( !strchr( HexStr , (int)buff[i] ) ){
				return ILLOPR;
			}
		}
		/* PUiɕϊ */
#if FORDOS
		if ( sscanf( &buff[1] , "%Lx" , &sts ) == EOF ) return ILLOPR;
#else
		if ( sscanf( &buff[1] , "%x" , &sts ) == EOF ) return ILLOPR;
#endif
		/* ͈̓I[o[ł */
		if ( sts >= 65536 ) return OFLOW;
		/* I */
		*data = (unsigned int )sts;
		return NORM;
	}
	/* POi */
	for( i = 0 ; i < len ; i++ ){
		/* `FbN */
		if( !strchr( DecStr , (int)buff[i] ) ) return ILLOPR;
	}
	/* POiɕϊ */
#if FORDOS
	if ( sscanf( buff , "%Ld" , &sts ) == EOF ) return ILLOPR;
#else
	if ( sscanf( buff , "%d" , &sts ) == EOF ) return ILLOPR;
#endif

	/* ͈̓I[o[ł */
	if ( sts >= 65536 ) return OFLOW;

	/* I */
	*data = (unsigned int )sts;
	return NORM;
}
#if _Support_SA
/**********************************************************************/
/*   PrintString() : Print Area Datap}N`                      */
/**********************************************************************/
#define PrintString()	\
{ \
	/* \ */ \
	sprintf(&OutTbl.opr[0][0] ,"\"%s\"",oprwk  ); \
	l = ( k <= 4 ) ? k : 4; \
	memcpy( OutTbl.code , oprwk , l ); \
	OutTbl.byte = l; \
	/* Xg(ŏ̍s)o */ \
	PrintList(); \
	/* jjbNA */ \
	OutTbl.mn[0]=0; \
	OutTbl.label[0]=0; \
	OutTbl.opr[0][0]=0; \
	OutTbl.opr[1][0]=0; \
	OutTbl.opr[2][0]=0; \
	/* cf[^o͂ */ \
	while( l < k ){ \
		/* ݂̃AZuAhXXV */ \
		OutTbl.adr = OutTbl.adr + OutTbl.byte; \
		OutTbl.byte = ( (k-l) <= 4 ) ? (k-l) : 4; \
		/* R[ho͂ */ \
		if ( !NoCode ){ \
			memcpy( OutTbl.code , &oprwk[l] , OutTbl.byte ); \
			/* Xgo */ \
			PrintList(); \
		} \
		l = l + OutTbl.byte; \
	} \
	k = 0; \
}

/**********************************************************************/
/*   PrintArea : Print Area Data                                      */
/*                                                                    */
/*       : w͈͂̃f[^Xgt@Co͂             */
/*       : sԍJE^                                         */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void PrintArea( unsigned int start , unsigned int end )
{
char lblwk[MAXLBL+2];
unsigned int adr,Sadr;
int i,j,k,l,flag;
SATBL Tbl;
int data,mask;
//	printf("PrintArea(%04xh,%04xh)\n",StartAdr+start,StartAdr+end);
	/* f[^o͊JnAhX */
	Sadr = start;
	flag = 0;
	/* Sf[^Xgo͂I */
	for( adr = start ; adr <= end ; )
	{
		/* SAo^̈ł */
		if (!GetArea((StartAdr+adr),&Tbl))
		{
			/* Oo͍ŏIASÄ܂ło */
			if (Sadr < adr)
			{
				PrintData(Sadr,adr-1);
				Sadr = adr;
			}
#if FORDOS
			fseek( TmpFD, (long)adr, SEEK_SET );
#endif
			/* SAo^̈悪end𒴂ꍇ */
			if(( adr + Tbl.byte ) > end ){
				/* SÄTCY𐧌 */
				Tbl.byte = ( end - adr ) + 1;
				/* [hwł */
				if( Tbl.type == SA_DW ){
					/* TCY̏ꍇA␳(-1) */
					Tbl.byte &= 0xffffe;
				}
			}
			/* SÄo */
			switch(Tbl.type)
			{
			case SA_DW:
				/* 2oCgɃXgo͂ */
				for( i = 0 ;i < (int)Tbl.byte ;i+=2 ){
					/* R[hϊobt@ */
					memset( &OutTbl.adr,0, sizeof(OUTTBL));
					/* jjbNo^ */
					sprintf( OutTbl.mn ,"DW" );
					OutTbl.byte = 2;
					/* ݂̃AZuAhXo^ */
					OutTbl.adr = StartAdr+adr+i;
					/* x̂ɕϊ */
					GetLabel( OutTbl.label, OutTbl.adr );
#if FORDOS
					/* f[^ǂ݂ */
					data = fgetc(TmpFD);
					OutTbl.code[0] = data;
					data = fgetc(TmpFD);
					OutTbl.code[1] = data;
#else
					/* f[^ǂ݂ */
					OutTbl.code[0] = OutBuf[adr+i];
					OutTbl.code[1] = OutBuf[adr+i+1];
#endif
					/* [hf[^쐬 */
					data = (OutTbl.code[1]&0xff)|((OutTbl.code[0]&0xff)<<8);
					if ( !GetLabel( lblwk, data ) ){
						/* f[^xo */
						sprintf(&OutTbl.opr[0][0] ,"%s",lblwk  );
						/* xRg𒊏o */
						GetLabelCmt(lblwk , OutTbl.comment );
					}
					else{
						/* f[^o͂ */
						sprintf(&OutTbl.opr[0][0] ,"$%04X",data  );
					}
					/* Xgo */
					PrintList();
				}
				break;
			case SA_STR:
				/* oCgɃXgo͂ */
				for( i = 0 ,j = 0 ,k = 0 ;i < (int)Tbl.byte ; ){
#if FORDOS
					/* f[^ǂ݂ */
					data = fgetc(TmpFD);
#else
					data = OutBuf[adr+i];
#endif
					/* LN^R[hȊOoꍇ(ꕶ2ByteR[h͕OƂ) */
					if((data == 0x22 )
					||( data < 0x20 )
					||((data & 0xf0) == 0x80)
					||((data & 0xf0) == 0x90)
					||( data > 0xe0)){
						/* I */
						if(k){
							PrintString();
						}
						/* DBJEg */
						j++;
						i++;
					}
					else{
						/* LN^R[hȊODB_v */
						if(j){
							OutTbl.byte = j;
							PrintData(adr+i-j,adr+i-1);
							j = 0;
						}
						if (!k){
							/* R[hϊobt@ */
							memset( &OutTbl.adr,0, sizeof(OUTTBL));
							/* obt@ */
							memset( oprwk , 0 , MAXLINE );
							/* jjbNo^ */
							sprintf( OutTbl.mn ,"DB" );
							/* ݂̃AZuAhXo^ */
							OutTbl.adr = StartAdr+adr+i;
							/* x̂ɕϊ */
							GetLabel( OutTbl.label, OutTbl.adr );
						}
						/* obt@ɓo^ */
						oprwk[k++] = (unsigned char)data;
						i++;
						
						/* Iyhő咷ɒBH */
						if (!GetLabel( lblwk , StartAdr+adr+i )||( k >= MAXMN ) ){
							/* obt@̕o͂ */
							PrintString();
						}
					}
				}
				/* LN^R[hȊODB_v */
				if(j){
					OutTbl.byte = j;
					PrintData(adr+i-j,adr+i-1);
					j = 0;
				}
				/* I */
				if(k){
					PrintString();
				}
				break;
			case SA_BIN:
				/* 摜C[Wo͎wł */
				if( OutputImg ){
					/* rbg}bvC[Wo͂ */
					if( !ImageDump( Sadr, Tbl.byte ,Tbl.div ) ){
						/* Xgo */
						PrintList();
						break;
					}
				}
				/* oCgɃXgo͂ */
				for( i = 0 ;i < (int)Tbl.byte ;i++ )
				{
					/* R[hϊobt@ */
					memset( &OutTbl.adr,0, sizeof(OUTTBL));
					/* jjbNo^ */
					sprintf( OutTbl.mn ,"DB" );
					strcpy( &OutTbl.opr[0][0],"&B" );
					OutTbl.byte = 1;
					/* ݂̃AZuAhXo^ */
					OutTbl.adr = StartAdr+adr+i;
					/* x̂ɕϊ */
					GetLabel( OutTbl.label, OutTbl.adr );
#if FORDOS
					/* f[^ǂ݂ */
					data = fgetc(TmpFD);
					OutTbl.code[0] = data;
#else
					/* f[^ǂ݂ */
					OutTbl.code[0] = OutBuf[adr+i];
#endif
					/* f[^o͂ */
					data = (unsigned int)OutTbl.code[0];
					for ( j = 0, mask = 0x80 ; j < 8 ; j++ )
					{
						OutTbl.opr[0][j+2] = (data & mask) ? (unsigned char)'1' : (unsigned char)'0';
						mask = mask>>1;
					}
					/* Xgo */
					PrintList();
				}
				break;
			case SA_DB:
			default:
				PrintData(Sadr, Sadr+Tbl.byte-1);
				break;
			}
			adr += Tbl.byte;
			Sadr = adr;
			flag = 0;
		}
		else
		{
			flag = 1;
			adr++;
		}
	}
	if ((flag)&&(Sadr!=end)){
		PrintData(Sadr, end);
	}
}
#endif /* _Support_SA */
/**********************************************************************/
/*   ImageDump : Bitmap Image Dump                                    */
/*                                                                    */
/*       : BMP`Ńt@Cɏo͂                            */
/*       : sԍJE^                                         */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
int ImageDump( unsigned int start , unsigned int max_size , unsigned int div )
{
FILE	*ImgFD;		/* t@CfBXNv^ */
char lblwk[MAXLEN];	/* t@C쐬[N */
unsigned int	x,y,v,cnt,n,msk;
unsigned int	rwidth,width,height,size;
int	rc = 0;
	
	/* C[Wϊobt@TCY̏ꍇAI */
	if ( max_size > sizeof(ImgTbl))
		return 1;
	
	/* AZuAhXo^ */
	OutTbl.adr = StartAdr + start;
	
	/* ݂̃AhXx̂ɕϊ */
	if ( !GetLabel( OutTbl.label,OutTbl.adr ) ){
		/* t@Cx.bmpƂ */
		sprintf( lblwk ,"%s.bmp" ,OutTbl.label );
	}
	else{
		/* t@CImg+AhX.bmpƂ */
		sprintf( lblwk ,"Img%04X.bmp" ,OutTbl.adr);
	}
	/* incbin߃Zbg(jjbNTCYz邪ÃIyhƘAȂ̂OK)*/
	strcpy( OutTbl.mn ,"INCBIN");
	/* t@CZbg */
	sprintf( &OutTbl.opr[0][0] ,"(%s)",lblwk );
	/* Xgփf[^o͂͂Ȃ */
	OutTbl.byte = 0;
	
	/* C[We[u */
	memset( ImgTbl , 0xff , sizeof(ImgTbl) );
	/* BMPwb_f[^ */
	memcpy( ImgTbl , Head1 ,62 );

	/* 摜=8bit */
	height = 8;
	width = !(max_size % 32) ? max_size : ((max_size/32)+1)*32;
	rwidth = max_size;
	/* w肠 */
	if( div > 1 ){
		width = !(div % 32) ? div : ((div/32)+1)*32;
		/* Ŋ؂TCY̏ꍇ */
		if( ( max_size % div ) == 0 ){
			/* Ő܂Ԃ */
			height = ( max_size / div ) * 8;
		}
		else{
			/* Ő܂Ԃ */
			height = (( max_size / div )+1) * 8;
		}
		rwidth = div;
	}
	size = (width/8)*height;
	/* 摜TCYZbg */
	Setlong( 2 , (size+62) );/* t@CTCY */
	Setlong( 18 , rwidth );  /*  */
	Setlong( 22 , height );  /*  */
	Setlong( 34 , size );    /* C[WTCY */
#if 0
	printf("width  = %d\n",width );
	printf("height = %d\n",height );
	printf("rwidth = %d\n",rwidth );
	printf("size   = %d\n",size );
#endif
	/* 摜t@COPEN */
	if ( ( ImgFD = fopen( lblwk ,"wb" ) ) <= 0 ){
		printf("Bitmap File [%s] not crated.\n",lblwk);
		return 1;
	}
	/* BMPwb_o (62byte) */
	for ( cnt = 0 ; cnt < 62 ; cnt++ )
		fputc( ImgTbl[cnt] , ImgFD );
	
	/* C[We[u */
	memset( ImgTbl , 0xff , sizeof(ImgTbl) );
#if FORDOS
	/* ϊf[^obt@m */
	if ( !(OutBuf = malloc( (size_t)max_size ))){
		printf("Output Buffer Not Allocated.\n");
		/* ϊI */
		rc = 1;
		goto conv_end;
	}
	/* obt@ */
	memset( OutBuf , 0 , (size_t)max_size );
	/* ǂݏoʒúAe|t@Cł */
	if ( start < OutCnt ){
		/* e|t@Cǂ݂(G[͖ēǂ߂邾ǂ) */
		fseek( TmpFD, start, SEEK_SET );
		fread( OutBuf , (size_t)max_size , (size_t)1 , TmpFD );
	}
#endif
	/* BMPC[Wϊ */
	v = width/8;
	y = height-1;
	x = 0;
	for( cnt = 0 ; ( cnt < (unsigned int)max_size )&&( (start+cnt) < OutCnt ) ; cnt++ ){
		/* rbg}bv肾 */
		for ( n = 0 , msk = 0x1 ; n < 8 ; n++ , msk*=2 ){
#if FORDOS
			/* rbgC[Wɕϊ */
			if( OutBuf[cnt] & msk ){
				ImgTbl[((y-n)*v)+(x/8)] ^= 0x80>>(x&7);
			}
#else
			/* rbgC[Wɕϊ */
			if ( OutBuf[start+cnt] & msk ){
				ImgTbl[((y-n)*v)+(x/8)] ^= (unsigned char)(0x80>>(x&7));
			}
#endif
//			printf("cnt,x,y,n,msk=%d %d %d %d %x\n",(int)cnt,(int)x,(int)y,(int)n,(int)msk);
		}
		/* x,yXV */
		if ( ++x >=rwidth ){
			y-=8;
			x=0;
		}
	}
	/* BMPC[Wo */
	for ( cnt = 0 ; cnt < (unsigned int)size ; cnt++ ){
		fputc( ImgTbl[cnt] , ImgFD );
	}
//	printf("Pixel Size = %d x %d %s File Created.\n", rwidth , height , lblwk );
conv_end:
	/* C[Wt@C */
	fclose(ImgFD);
#if FORDOS
	/* o̓obt@ */
	if( OutBuf ){
		free( OutBuf );
		OutBuf = 0;
	}
#endif
	return rc;
}
/**********************************************************************/
/*   PrintData : Print Data                                           */
/*                                                                    */
/*       : Xgt@Co͂                               */
/*       : sԍJE^                                         */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void PrintData( unsigned int start , unsigned int end )
{
char lblwk[MAXLBL+2];
unsigned int adr;
int i;
#if FORDOS
int data;
#endif
//	printf("PrintData(%04xh,%04xh)\n",start,end);
	for( adr = start ; adr <= end ; ){
		/* R[hϊobt@ */
		memset( &OutTbl.adr,0, sizeof(OUTTBL));
		/* SoCgo */
#if FORDOS
		fseek( TmpFD, (long)adr, SEEK_SET );
		fread( OutTbl.code , (size_t)4 , (size_t)1 , TmpFD );
		fseek( TmpFD, (long)adr, SEEK_SET );
#else
		memcpy( OutTbl.code , &OutBuf[adr] , 4 );
#endif
		/* ݂̃AZuAhXo^ */
		OutTbl.adr = StartAdr+adr;
		/* ݂̃AhXx̂ɕϊ */
		GetLabel( OutTbl.label,OutTbl.adr );
		sprintf( OutTbl.mn ,"DB" );
		/* PoCgo */
#if FORDOS
		data = fgetc(TmpFD);
		OutTbl.code[0] = data;
		sprintf(&OutTbl.opr[0][0] ,"$%02X", data );
		adr++;
#else
		OutTbl.code[0] = OutBuf[adr];
		sprintf(&OutTbl.opr[0][0] ,"$%02X", OutBuf[adr++] );
#endif
		OutTbl.byte = 1;
		/* őSoCgo */
		for ( i = 1 ; i < 4 ; i++ ){
			/* xf[^ */
			if ( !GetLabel( lblwk, (unsigned int)(StartAdr+adr) ) ) break;
			if ( adr > end ) break;
			/* PoCgo */
#if FORDOS
			data = fgetc(TmpFD);
			OutTbl.code[i] = data;
			sprintf(&OutTbl.opr[i][0] ,",$%02X", data );
#else
			OutTbl.code[i] = OutBuf[adr];
			sprintf(&OutTbl.opr[i][0] ,",$%02X", OutBuf[adr] );
#endif
			OutTbl.byte = i+1;
			adr++;
		}
		/* Xgo */
		PrintList();
	}
}

/***************************************************/
/*   }N`FOutputString()                    */
/*       : R[h𕶎ďo͂          */
/***************************************************/
/* }N` */
#define	OutputString()	\
{ \
	if (pr) printf( "\"" ); \
	fprintf( LstFD ,"\"" ); \
	for ( cnt = 0 ; cnt < 4 ; cnt++ ){ \
		if ( cnt < (int)OutTbl.byte){ \
			switch(OutTbl.code[cnt]&0xf0){ \
			case 0x0: \
			case 0x10: \
			case 0x80: \
			case 0x90: \
			case 0xe0: \
			case 0xf0: \
				n = 1; \
				break; \
			default: \
				n = 0; \
				break; \
			} \
			if (pr) printf( "%c" , n ? 0x20 : OutTbl.code[cnt] ); \
			fprintf( LstFD ,"%c" , n ? 0x20 : OutTbl.code[cnt] ); \
		} \
	} \
	if (pr) printf( "\"\t" ); \
	if (!Tab){ \
		fprintf( LstFD ,"\"" ); \
		n = 7 - (int)OutTbl.byte; \
		for ( i = 0 ; i < n ; i++ ) \
			fprintf( LstFD ," " ); \
	} \
	else { \
		fprintf( LstFD ,"\"\t" ); \
	} \
}
/**********************************************************************/
/*   PrintList : Print List File                                      */
/*                                                                    */
/*       : Xgt@Co͂                               */
/*       : sԍJE^                                         */
/*   o    : Ȃ                                                   */
/*                                                                    */
/**********************************************************************/
void PrintList( void )
{
char lblwk[MAXLBL+2];
char comment[MAXCOMM];
unsigned int adr;
int	i,j,cnt,n,len;
	len = 0;
	n=0;

	/* xRgo */
	memset(comment,0,MAXCOMM);
	/* xR[ho */
	if ( OutTbl.label[0] ){
		if ( !NoCode ){
			/* sԍo */
			if (pr) printf( "%04X: " , OutTbl.adr );
			fprintf( LstFD ,"%04X: " , OutTbl.adr );

			/* f[^Ȃ */
			if (pr) printf( "                   " );
			if (!Tab) fprintf( LstFD ,"                   " );
			else fprintf( LstFD ,"\t\t\t" );
		}

		sprintf( comment , "%s:" , OutTbl.label );
		if (pr) printf("%-10s" , comment );
		if (!Tab) fprintf( LstFD ,"%-10s" , comment );
		else{
			fprintf( LstFD ,"%s" , comment );
			if ( strlen(comment) < 8 )
				fprintf( LstFD ,"\t" );
		}
		/* s㔼ɃAhXo͂ */
		if( NoCode == 2 ){
			if (!Tab){
				n = ( strlen(lblwk) > 10 ) ? ( 30 - strlen(lblwk) ) : 30;
				for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ," " );
				fprintf( LstFD ,";%04X: " , OutTbl.adr );
			}
			else{
				fprintf( LstFD ,"\t\t\t\t;%04X: " , OutTbl.adr );
			}
		}
		/* xRgo */
		memset(comment,0,MAXCOMM);
		if(!GetLabelCmt(OutTbl.label, comment)){
			if(comment[0]){
				if (pr) printf( "\t\t\t\t; %s" , comment );
				if (!Tab){
					/* AhXo͂ */
					if( NoCode == 2 ){
						fprintf( LstFD ,"                   : %s" , comment );
					}
					else{
						n = ( strlen(lblwk) > 10 ) ? ( 30 - strlen(lblwk) ) : 30;
						for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ," " );
						fprintf( LstFD ,"; %s" , comment );
					}
				}
				else{
					/* AhXo͂ */
					if( NoCode == 2 ){
						fprintf( LstFD ,"\t\t\t: %s" , comment );
					}
					else{
						fprintf( LstFD ,"\t\t\t\t; %s" , comment );
					}
				}
			}
		}
		/* s */
		if (pr) printf( "\n" );
		fprintf( LstFD ,"\n" );
	}

	/* R[ho͂ */
	if ( !NoCode ){
		/* sԍo */
		if (pr) printf( "%04X: " , OutTbl.adr );
		fprintf( LstFD ,"%04X: " , OutTbl.adr );

		/* ORG߈ȊO͖ߌR[ho */
		if (OutTbl.byte){
			/* f[^ */
			for ( cnt = 0 ; cnt < 4 ; cnt++ ){
				if ( cnt < (int)OutTbl.byte){
					if (pr) printf( "%02X" , OutTbl.code[cnt] );
					fprintf( LstFD ,"%02X" , OutTbl.code[cnt] );
				}
				else{
					if (pr) printf( "  " );
					if (!Tab) fprintf( LstFD ,"  " );
				}
			}
			if (pr) printf( "  " );
			if (!Tab) fprintf( LstFD ,"  " );
			else fprintf( LstFD ,"\t" );
			
			/* o */
			OutputString();
		}
		else{
			/* f[^Ȃ */
			cnt = OutTbl.byte;
			if (pr) printf( "              " );
			if (!Tab) fprintf( LstFD ,"              " );
			else fprintf( LstFD ,"\t\t\t" );
		}
	}
	/* 󔒏o */
	if (pr) printf( "          " );
	if (!Tab) fprintf( LstFD ,"          " );
	else fprintf( LstFD ,"\t" );
	
	/* jjbNo */
	if (pr) printf( "%-08s" , &OutTbl.mn[0] );
	if (!Tab) fprintf( LstFD ,"%-08s" , &OutTbl.mn[0] );
	else{
		fprintf( LstFD ,"%s" , &OutTbl.mn[0] );
		if ( strlen(&OutTbl.mn[0]) < 8 )
			fprintf( LstFD ,"\t" );
	}
	len += 8;
	/* Iyho͏ */
	i = 0;
	/* jjbNopr0̈܂ŒBĂ */
	if ( strlen(OutTbl.mn) > 8 ){
		/* \␳ */
		len += strlen(OutTbl.opr[0]);
		/* opr0͕\Ȃ */
		i = 1;
	}
	/* Iyho͎s */
	while( OutTbl.opr[i][0] ){
		if (pr) printf( "%s" , &OutTbl.opr[i][0] );
		fprintf( LstFD ,"%s" , &OutTbl.opr[i][0] );
		len += strlen(OutTbl.opr[i]);
		i++;
	}
	/* 㔼ɃAhXo͂ */
	if( NoCode == 2 ){
		/* 󔒏o */
		if ( len ){
			if (!Tab){
				n = ( len > 30 ) ? 0 : ( 30 - len );
				for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ," " );
			}
			else{
				n = ( len > 31 ) ? 0 : ( 4 - (len/8) );
				for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ,"\t" );
			}
		}
		/* AhXo */
		if (pr) printf( ";%04X: " , OutTbl.adr );
		fprintf( LstFD ,";%04X: " , OutTbl.adr );
		
		/* f[^ */
		for ( cnt = 0 ; cnt < 4 ; cnt++ ){
			if ( cnt < (int)OutTbl.byte){
				if (pr) printf( "%02X" , OutTbl.code[cnt] );
				fprintf( LstFD ,"%02X" , OutTbl.code[cnt] );
			}
			else{
				if (pr) printf( "  " );
				if (!Tab) fprintf( LstFD ,"  " );
			}
		}
		if (pr) printf( "  " );
		if (!Tab) fprintf( LstFD ,"  " );
		else fprintf( LstFD ,"\t" );
		
		/* o */
		OutputString();
		/* Rgo */
		if ( OutTbl.comment[0] ){
			fprintf( LstFD ,": %s" , OutTbl.comment );
		}
		/* f[^6ȏ̏ꍇA2sڈȍ~\ */
		if(!strcmp(OutTbl.mn,"DB") && strlen(OutTbl.opr[0])>6 && OutTbl.opr[0][0]=='\"'){
			/* JnAhX+4 */
			adr = OutTbl.adr + 4;
			/* _uR[e[V(1)␳ */
			len = strlen(OutTbl.opr[0]) - 1;
			for ( i = 5 ; i < len ; i += 4 ,adr += 4 ){
				/* Cfg{AhXo */
				fprintf( LstFD ,"\n\t\t\t\t\t;%04X: ", adr );
				
				cnt = (len > 4) ? 4 : (len-i);
				
				for ( n = 0 ; n < cnt ; n++ ){
					if(OutTbl.opr[0][i+n]!='\"'){
						fprintf( LstFD ,"%02X", (unsigned char)OutTbl.opr[0][i+n] );
					}
					else{
						j = cnt-n;
						for ( n = 0 ; n < j ; n++ ){
							fprintf( LstFD ,"  " );
						}
						break;
					}
				}
				fprintf( LstFD ,"\t\"" );
				for ( n = 0 ; n < cnt ; n++ ){
					if(OutTbl.opr[0][i+n]!='\"'){
						fprintf( LstFD ,"%c", OutTbl.opr[0][i+n] );
					}
					else break;
				}
				fprintf( LstFD ,"\"\t" );
			}
		}		
	}
	else{
		/* Rgo */
		if ( OutTbl.comment[0] ){
			if (pr) printf( "%s" , OutTbl.comment );
			/* 󔒏o */
			if ( len ){
				if (!Tab){
					n = ( len > 30 ) ? 0 : ( 30 - len );
					for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ," " );
				}
				else{
					n = ( len > 31 ) ? 0 : ( 4 - (len/8) );
					for ( i = 0 ; i < n ; i++ ) fprintf( LstFD ,"\t" );
				}
			}
			fprintf( LstFD ,"; %s" , OutTbl.comment );
		}
	}
	/* s */
	if (pr) printf( "\n" );
	fprintf( LstFD ,"\n" );
}
