/********************************************************************/
/*                                                                  */
/*  NAME : SC61860 DISASSEMBLER HEADDER CODE                        */
/*  FILE : DSC61860.h                                               */
/*  Copyright (c)  'BLUE' 2006-2023                             */
/*                                                                  */
/*  REVISION HISTORY:                                               */
/*  Rev : 0.01 2006.10.13  JJn                                 */
/*  Rev : 0.02 2006.10.16  CASE1/CASE2ΉBRgo͂ǁB    */
/*  Rev : 0.03 2006.11.07  sRgC                       */
/*  Rev : 0.05 2009.11.20  IYS/IXSRgo͂                */
/*  Rev : 0.06 2021.07.11  unsigned int -> unsigned int ɕύX      */
/*                         unsigned int-> unsigned int ɕύX       */
/*  Rev : 0.08 2022.04.30  SA^߂T|[g                     */
/*                         Rgo͋@\\ǉ           */
/*                         xe[uQƃtOǉ             */
/*                         Bitmapop}N`(Setlong)ǉ  */
/*  Rev : 0.09 2023.06.18  l̃x`̃G[ǉ         */
/*                         includep萔^G[`ǉ            */
/*                                                                  */
/********************************************************************/
#define		_Support_SA	1			/* 1:SA^߂T|[g       */
/*------------------------------------------------------------------*/
/*  萔`                                                        */
/*------------------------------------------------------------------*/
#define		MAXNAME		8			/* xő咷                 */
#define		MAXLEN		32			/* Iyhő咷             */
#define		MAXOPR		4			/* Iyh               */
#define		MAXLINE		256			/* PsőoCg             */
#define		MAXMN		6			/* jjbNő咷(6)      */
#define		MAXLBL		8			/* xő咷(8)          */
#define		MAXCOMM		80			/* commentő咷(80)        */
#define		MAXINC		256			/* őCN[hlXg     */

/*------------------------------------------------------------------*/
/*  \͌ʏo̓e[u\̒`iOutTblj                    */
/*------------------------------------------------------------------*/
typedef struct outtbl {
	unsigned int adr;				/* ߊi[AhX             */
	unsigned int byte;				/* ߃oCg(0:Rĝ) */
	unsigned char  code[8];			/* ߃R[h                   */
	char  label[MAXLBL+2];			/* x                   */
	char  mn[MAXMN];				/* jjbN                   */
	char  opr[5][MAXLEN+2];			/* Iyh                   */
	char  comment[MAXCOMM+2];		/* Rg                     */
} OUTTBL;

/*------------------------------------------------------------------*/
/*  xe[u\̒`ilbltblj                              */
/*------------------------------------------------------------------*/
typedef struct lbl {
	void * np;						/* x\̃|C^       */
	unsigned int adr;				/* ΉAhX                 */
	unsigned int flag;				/* tO(1:QƂ)       */
	char	name[MAXLBL+2];			/* x                   */
	char  comment[1];				/* Rg(1Byteȏ)          */
} LBL;

#if _Support_SA
/*------------------------------------------------------------------*/
/*  SA^ߍ\̒`iSetAreaTblj                              */
/*------------------------------------------------------------------*/
typedef struct SetAreaTbl {
	void * np;						/* SA\̃|C^           */
	unsigned char type;				/* f[^^Cv                 */
	unsigned int adr;				/* JnAhX                 */
	unsigned int byte;				/* ̈oCg(0:Rĝ) */
	unsigned int div;				/* ̈̕ALڂ   */
} SATBL;

/* f[^^Cv` */
enum{
	SA_DB	=	0	,				/* ʏ(Byte)                   */
	SA_DW			,				/* [h(word)                 */
	SA_STR			,				/* (ASCII)                */
	SA_BIN							/* oCi(2i)              */
};
#endif /* _Support_SA */
/*------------------------------------------------------------------*/
/*  ef[^ϊe[u\̒`                                */
/*------------------------------------------------------------------*/
/* if`else`endif}Nϊe[u */
#define		IFLEVEL     255         /* iflXgx */
#define		OP_IF		0			/* if    */
#define		OP_ELSE		1			/* else  */
#define		OP_ENDIF	2			/* endif */

#define		LBLOK		0x000d		/* ʃx AhXς  */
#define		LBLNG		0x000e		/* ʃx AhX    */

/* Iyhϊe[u\ */
typedef struct opr {
	unsigned int code;				/* IyhR[hԍ         */
	char	name[9];				/* Iyh               */
} OPR;

#define		MACDIR		3
struct opr MacTbl[MACDIR] = {
{	OP_IF		,	"IF"		},
{	OP_ELSE		,	"ELSE"		},
{	OP_ENDIF	,	"ENDIF"		}
};

/* IyR[h */
enum{
	OP_UNKNOWN = 0x0,	/* s(DB߂ɕϊ)              */
	OP_NUL			,	/* Iyhi1oCg߁j   */
	OP_8			,	/* 8rbgIyh(2oCg)  */
	OP_16			,	/* 16rbgIyh(3oCg) */
	OP_JRP			,	/* ΃Wv+i2oCg߁j*/
	OP_JRM			,	/* ΃Wv-i2oCg߁j*/
	OP_LP			,	/* LP߁i1oCg߁j           */
	OP_CAL			,	/* CAL߁i1oCg߁j          */
	OP_CASE1		,	/* CASE1߁i4oCg߁j        */
	OP_CASE2		,	/* CASE2߁i4oCg߁j        */
	CASE2_OP			/* CASE2Iyhi3xKoCgj    */
};

/* ߕϊe[u\ */
typedef struct fnc {
	unsigned char	code;			/* ߃R[hԍ               */
	unsigned char	byte;			/* ߃oCg                 */
	unsigned char	kind;			/* ߌ(i[)   */
	char			name[MAXMN];	/* jjbN               */
	char			comment[40];	/* ߃Rg                 */
} FNC;
#define		MAXOP	132
struct fnc codetbl[MAXOP] = {
/*	opcode	,byte,	kind,jjbN	,comment	*/
/*									,"0123456789012345678901234567890123456789" */
{	0x00,	2,	 OP_8	,"LII"		,"I=%02Xh"								},
{	0x01,	2,	 OP_8	,"LIJ"		,"J=%02Xh"								},
{	0x02,	2,	 OP_8	,"LIA"		,"A=%02Xh"								},
{	0x03,	2,	 OP_8	,"LIB"		,"B=%02Xh"								},
{	0x04,	1,	 OP_NUL	,"IX"		,"X=X+1, DP=X"							},
{	0x05,	1,	 OP_NUL	,"DX"		,"X=X-1, DP=X"							},
{	0x06,	1,	 OP_NUL	,"IY"		,"Y=Y+1, DP=Y"							},
{	0x07,	1,	 OP_NUL	,"DY"		,"Y=Y-1, DP=Y"							},
{	0x08,	1,	 OP_NUL	,"MVW"		,"(P)=(Q), P=P+1, Q=Q+1, I+1 bytes"		},
{	0x09,	1,	 OP_NUL	,"EXW"		,"(P)<->(Q), P=P+1, Q=Q+1, I+1 bytes"	},
{	0x0a,	1,	 OP_NUL	,"MVB"		,"(P)=(Q), P=P+1, Q=Q+1, J+1 bytes"		},
{	0x0b,	1,	 OP_NUL	,"EXB"		,"(P)<->(Q), P=P+1, Q=Q+1, J+1 bytes"	},
{	0x0c,	1,	 OP_NUL	,"ADN"		,"(P)=(P)+A, P=P-1"						},
{	0x0d,	1,	 OP_NUL	,"SBN"		,"(P)=(P)-A, P=P-1"						},
{	0x0e,	1,	 OP_NUL	,"ADW"		,"(P)=(P)+(Q), P=P-1, Q=Q-1"			},
{	0x0f,	1,	 OP_NUL	,"SBW"		,"(P)=(P)-(Q), P=P-1, Q=Q-1"			},
{	0x10,	3,	 OP_16	,"LIDP"		,"DP=%04Xh"								},
{	0x11,	2,	 OP_8	,"LIDL"		,"DPl=%02Xh"							},
{	0x12,	2,	 OP_8	,"LIP"		,"P=%02Xh"								},
{	0x13,	2,	 OP_8	,"LIQ"		,"Q=%02Xh"								},
{	0x14,	1,	 OP_NUL	,"ADB"		,"[P+1,P]=[P+1,P]+[BA]"					},
{	0x15,	1,	 OP_NUL	,"SBB"		,"[P+1,P]=[P+1,P]-[BA]"					},
{	0x18,	1,	 OP_NUL	,"MVWD"		,"(P)=(DP), P=P+1, DP=DP+1 I+1 bytes"	},
{	0x19,	1,	 OP_NUL	,"EXWD"		,"(P)<->(DP), P=P+1, DP=DP+1 I+1 bytes"	},
{	0x1a,	1,	 OP_NUL	,"MVBD"		,"(P)=(DP), P=P+1, DP=DP+1 J+1 bytes"	},
{	0x1b,	1,	 OP_NUL	,"EXBD"		,"(P)<->(DP), P=P+1, DP=DP+1 J+1 bytes"	},
{	0x1c,	1,	 OP_NUL	,"SRW"		,"[P,P+1] SHIFT RIGHT (4bit) I+1 bytes"	},
{	0x1d,	1,	 OP_NUL	,"SLW"		,"[P,P+1] SHIFT LEFT (4bit)  I+1 bytes"	},
{	0x1e,	1,	 OP_NUL	,"FILM"		,"(P)=A, P=P+1 I+1 bytes"				},
{	0x1f,	1,	 OP_NUL	,"FILD"		,"(DP)=A, (DP)=(DP)+1 I+1 bytes"		},
{	0x20,	1,	 OP_NUL	,"LDP"		,"A=P"									},
{	0x21,	1,	 OP_NUL	,"LDQ"		,"A=Q"									},
{	0x22,	1,	 OP_NUL	,"LDR"		,"A=R"									},
{	0x23,	1,	 OP_NUL	,"CLRA"		,"A=00h"								},
{	0x24,	1,	 OP_NUL	,"IXL"		,"X=X+1, DP=X, A=(DP)"					},
{	0x25,	1,	 OP_NUL	,"DXL"		,"X=X-1, DP=X, A=(DP)"					},
{	0x26,	1,	 OP_NUL	,"IYS"		,"Y=Y+1, DP=Y, (DP)=A"					},
{	0x27,	1,	 OP_NUL	,"DYS"		,"Y=Y-1, DP=Y, (DP)=A"					},
{	0x28,	2,	 OP_JRP	,"JRNZP"	,"IF Z=0 JUMP $%04X"					},
{	0x29,	2,	 OP_JRM	,"JRNZM"	,"IF Z=0 JUMP $%04X"					},
{	0x2a,	2,	 OP_JRP	,"JRNCP"	,"IF C=0 JUMP $%04X"					},
{	0x2b,	2,	 OP_JRM	,"JRNCM"	,"IF C=0 JUMP $%04X"					},
{	0x2c,	2,	 OP_JRP	,"JRP"		,"JUMP $%04X"							},
{	0x2d,	2,	 OP_JRM	,"JRM"		,"JUMP $%04X"							},
{	0x2f,	2,	 OP_JRM	,"LOOP"		,"(R)<-(R)-1:IF C=0 JUMP $%04X"			},
{	0x30,	1,	 OP_NUL	,"STP"		,"P=A"									},
{	0x31,	1,	 OP_NUL	,"STQ"		,"Q=A"									},
{	0x32,	1,	 OP_NUL	,"STR"		,"R=A"									},
{	0x34,	1,	 OP_NUL	,"PUSH"		,"PUSH A"								},
{	0x35,	1,	 OP_NUL	,"RST"		,"RESTART"								},
{	0x37,	1,	 OP_NUL	,"RTN"		,"RETURN"								},
{	0x38,	2,	 OP_JRP	,"JRZP"		,"IF Z=1 JUMP $%04X"					},
{	0x39,	2,	 OP_JRM	,"JRZM"		,"IF Z=1 JUMP $%04X"					},
{	0x3a,	2,	 OP_JRP	,"JRCP"		,"IF C=1 JUMP $%04X"					},
{	0x3b,	2,	 OP_JRM	,"JRCM"		,"IF C=1 JUMP $%04X"					},
{	0x40,	1,	 OP_NUL	,"INCI"		,"I=I+1"								},
{	0x41,	1,	 OP_NUL	,"DECI"		,"I=I-1"								},
{	0x42,	1,	 OP_NUL	,"INCA"		,"A=A+1"								},
{	0x43,	1,	 OP_NUL	,"DECA"		,"A=A-1"								},
{	0x44,	1,	 OP_NUL	,"ADM"		,"(P)=(P)+A"							},
{	0x45,	1,	 OP_NUL	,"SBM"		,"(P)=(P)-A"							},
{	0x46,	1,	 OP_NUL	,"ANMA"		,"(P)=(P) AND A"						},
{	0x47,	1,	 OP_NUL	,"ORMA"		,"(P)=(P) OR A"							},
{	0x48,	1,	 OP_NUL	,"INCK"		,"K=K+1"								},
{	0x49,	1,	 OP_NUL	,"DECK"		,"K=K-1"								},
{	0x4a,	1,	 OP_NUL	,"INCM"		,"M=M+1"								},
{	0x4b,	1,	 OP_NUL	,"DECM"		,"M=M-1"								},
{	0x4c,	1,	 OP_NUL	,"INA"		,"A=IA Port"							},
{	0x4d,	1,	 OP_NUL	,"NOPW"		,"NO OPERATION"							},
{	0x4e,	2,	 OP_8	,"WAIT"		,"WAIT %02Xh"							},
{	0x4f,	1,	 OP_NUL	,"CUP"		,"unknown"								},
{	0x50,	1,	 OP_NUL	,"INCP"		,"P=P+1"								},
{	0x51,	1,	 OP_NUL	,"DECP"		,"P=P-1"								},
{	0x52,	1,	 OP_NUL	,"STD"		,"(DP)=A"								},
{	0x53,	1,	 OP_NUL	,"MVDM"		,"(DP)=(P)"								},
{	0x54,	1,	 OP_NUL	,"READM"	,"unknown"								},
{	0x55,	1,	 OP_NUL	,"MVMD"		,"(DP)=(P)"								},
{	0x56,	1,	 OP_NUL	,"READ"		,"(P)=(DP)"								},
{	0x57,	1,	 OP_NUL	,"LDD"		,"A=(DP)"								},
{	0x58,	1,	 OP_NUL	,"SWP"		,"A1-4 <-> A5-8"						},
{	0x59,	1,	 OP_NUL	,"LDM"		,"A=(P)"								},
{	0x5a,	1,	 OP_NUL	,"SL"		,"SHIFT LEFT A"							},
{	0x5b,	1,	 OP_NUL	,"POP"		,"POP A"								},
{	0x5d,	1,	 OP_NUL	,"OUTA"		,"IA Port=(&5C)"						},
{	0x5f,	1,	 OP_NUL	,"OUTF"		,"F0 Port=(&5E)"						},
{	0x60,	2,	 OP_8	,"ANIM"		,"(P)=(P) AND %02Xh"					},
{	0x61,	2,	 OP_8	,"ORIM"		,"(P)=(P) OR %02Xh"						},
{	0x62,	2,	 OP_8	,"TSIM"		,"Z=(P) AND %02Xh"						},
{	0x63,	2,	 OP_8	,"CPIM"		,"Z,C=(P)-%02Xh"						},
{	0x64,	2,	 OP_8	,"ANIA"		,"A=A AND %02Xh"						},
{	0x65,	2,	 OP_8	,"ORIA"		,"A=A OR %02Xh"							},
{	0x66,	2,	 OP_8	,"TSIA"		,"Z=A AND %02Xh"						},
{	0x67,	2,	 OP_8	,"CPIA"		,"Z,C=A-%02Xh"							},
{	0x69,	1,	 OP_CASE2,"CASE2"	,"ON A GOTO..."							},
//{	0x69,	1,	 OP_NUL	,"JST"		,"unknown"								},
{	0x6b,	2,	 OP_8	,"TEST"		,"TEST=%02Xh"							},
{	0x6f,	1,	 OP_NUL	,"CDN"		,"unknown"								},
{	0x70,	2,	 OP_8	,"ADIM"		,"(P)=(P)+%02Xh"						},
{	0x71,	2,	 OP_8	,"SBIM"		,"(P)=(P)-%02Xh"						},
{	0x74,	2,	 OP_8	,"ADIA"		,"A=A+%02Xh"							},
{	0x75,	2,	 OP_8	,"SBIA"		,"A=A-%02Xh"							},
{	0x78,	3,	 OP_16	,"CALL"		,"CALL $%04X"							},
{	0x79,	3,	 OP_16	,"JP"		,"JUMP $%04X"							},
{	0x7a,	4,	 OP_CASE1,"CASE1"	,"K=%02Xh, PUSH %04Xh"					},
//{	0x7a,	1,	 OP_NUL	,"SETT"		,"unknown"								},
{	0x7c,	3,	 OP_16	,"JPNZ"		,"IF Z=0 JUMP $%04X"					},
{	0x7d,	3,	 OP_16	,"JPNC"		,"IF C=0 JUMP $%04X"					},
{	0x7e,	3,	 OP_16	,"JPZ"		,"IF Z=1 JUMP $%04X"					},
{	0x7f,	3,	 OP_16	,"JPC"		,"IF C=1 JUMP $%04X"					},
{	0x80,	1,	 OP_LP	,"LP"		,"P=%02Xh"								},
{	0xc0,	1,	 OP_NUL	,"INCJ"		,"J=J+1"								},
{	0xc1,	1,	 OP_NUL	,"DECJ"		,"J=J-1"								},
{	0xc2,	1,	 OP_NUL	,"INCB"		,"B=B+1"								},
{	0xc3,	1,	 OP_NUL	,"DECB"		,"B=B-1"								},
{	0xc4,	1,	 OP_NUL	,"ADCM"		,"(P)=(P)+A+C"							},
{	0xc5,	1,	 OP_NUL	,"SBCM"		,"(P)=(P)-A-C"							},
//{	0xc6,	1,	 OP_NUL	,"TSMA"		,"unknown"								},
{	0xc7,	1,	 OP_NUL	,"CPMA"		,"Z,C=(P)-A"							},
{	0xc8,	1,	 OP_NUL	,"INCL"		,"L=L+1"								},
{	0xc9,	1,	 OP_NUL	,"DECL"		,"L=L-1"								},
{	0xca,	1,	 OP_NUL	,"INCN"		,"N=N+1"								},
{	0xcb,	1,	 OP_NUL	,"DECN"		,"N=N-1"								},
{	0xcc,	1,	 OP_NUL	,"INB"		,"A=IB Port"							},
//{	0xce,	1,	 OP_NUL	,"NOPT"		,"unknown"								},
{	0xd0,	1,	 OP_NUL	,"SC"		,"Z=1, C=1"								},
{	0xd1,	1,	 OP_NUL	,"RC"		,"Z=1, C=0"								},
{	0xd2,	1,	 OP_NUL	,"SR"		,"SHIFT RIGHT A"						},
{	0xd4,	2,	 OP_8	,"ANID"		,"(DP)=(DP) AND %02Xh"					},
{	0xd5,	2,	 OP_8	,"ORID"		,"(DP)=(DP) OR %02Xh"					},
{	0xd6,	2,	 OP_8	,"TSID"		,"Z=(DP) AND %02Xh"						},
{	0xd8,	1,	 OP_NUL	,"LEAVE"	,"(R)=0"								},
{	0xda,	1,	 OP_NUL	,"EXAB"		,"A<->B"								},
{	0xdb,	1,	 OP_NUL	,"EXAM"		,"A<->(P)"								},
{	0xdd,	1,	 OP_NUL	,"OUTB"		,"IB=(&5D)"								},
{	0xdf,	1,	 OP_NUL	,"OUTC"		,"CONTROL=(&5F)"						},
{	0xe0, 	2,	 OP_CAL	,"CAL"		,"CALL $%04X"							}
};

/*------------------------------------------------------------------*/
/*  G[ʒ`                                                  */
/*------------------------------------------------------------------*/
enum{
	NORM	=	0	,		/* I                     */
	EOFERR			,		/* t@CI                 */
	LOFLOW			,		/* Ps̕I[o[   */
	OPOFLOW			,		/* IyhI[o[ */
	LBOFLOW			,		/* Ps̕I[o[   */
	NOORG			,		/* ORGߒ`Ȃ            */
	ILLOPR			,		/* IyhLq~X           */
	ILLDQUO			,		/* ٺð/ ُ       */
	DUPLBL			,		/* xLqQȏ゠     */
	ILLLBL			,		/* xɗpłȂ     */
	LBLNOENT		,		/* xo^Ȃ               */
	LBNOALOC		,		/* xo^Ȃ               */
	UNDEFOPR		,		/* Y߂Ȃ/Lq@̃~X  */
	OFLOW			,		/* Iyhl͈͊O         */
	CALERR			,		/* vZُ( 0 Z )   */
#if _Support_SA
	SANOALOC		,		/* SAo^s(mNG)     */
	DUPADR			,		/* SAo^s(AhXd)     */
#endif /* _Support_SA */
	INCNOFILE		,		/* #includet@CȂ       */
	INCERR			,		/* #includelXgُ           */
	IFNEST			,		/* #if`#else`#endiflXgُ */
	SAMEIMM					/* l̃xo(Warning)*/
};
/* G[bZ[Wϊe[u\ */
typedef struct err {
	unsigned short code;			/* R[hԍ                   */
	char	msg[32];				/* G[bZ[W(32ȓ) */
} ERR;

/* G[bZ[Wϊe[u */
#if _Support_SA
#define		MAXERR		21
#else
#define		MAXERR		19
#endif /* _Support_SA */
struct err errtbl[MAXERR] = {
{	LOFLOW	    ,	"Line Length is Too Long"		},
{	OPOFLOW	    ,	"Oprand Length is Too Long"		},
{	LBOFLOW	    ,	"LABEL Length is Too Long"		},
{	NOORG	    ,	"ORG Not Entry"					},
{	ILLOPR	    ,	"Illegal Operand"				},
{	ILLDQUO	    ,	"Illegal ['']or[(]or[)]"		},
{	DUPLBL	    ,	"LABEL Already Defined"			},
{	ILLLBL	    ,	"LABEL Type Mismatch"			},
{	LBLNOENT    ,	"Undefined LABEL"				},
{	LBNOALOC    ,	"Could Not Defined LABEL"		},
{	OFLOW	    ,	"Operand Range Over"			},
{	UNDEFOPR    ,	"Operation Type Mismatch"		},
{	OFLOW	    ,	"Operand Range Over"			},
{	CALERR	    ,	"Could Not Calculate"			},
{	INCNOFILE   ,	"Invalid Include File Name"		},
{	INCERR	    ,	"Could Not Nest Include"		},
{	IFNEST	    ,	"Illegal [#if] - [#endif]"		},
{	SAMEIMM	    ,	"Labels of the same value exist"},
#if _Support_SA
{	SANOALOC    ,	"Could Not Defined LABEL"		},
{	DUPADR	    ,	"SA Address Already Defined"	},
#endif /* _Support_SA */
{	0		    ,	"Normal"						}
};

/*------------------------------------------------------------------*/
/*  rbg}bv쐬pwb_i蔲j                          */
/*------------------------------------------------------------------*/
/* }N` */
#define	Getlong(x) (((unsigned int)ImgTbl[x+3])<<24)+(((unsigned int)ImgTbl[x+2])<<16)+(((unsigned int)ImgTbl[x+1])<<8)+((unsigned int)ImgTbl[x]&0xff)
#define	Getword(x) ((((unsigned int)ImgTbl[x+1])<<8)+(unsigned int)ImgTbl[x])
#define	Getparret(x) (((unsigned int)ImgTbl[x+2])+((unsigned int)ImgTbl[x+1])+(unsigned int)ImgTbl[x])
#define	Setlong(x,n) { \
	ImgTbl[x+3] = (unsigned char)((n>>24)&0xff); \
	ImgTbl[x+2] = (unsigned char)((n>>16)&0xff); \
	ImgTbl[x+1] = (unsigned char)((n>>8)&0xff); \
	ImgTbl[x] = (unsigned char)(n&0xff); \
}

/* 192*32 pxcel */
unsigned char Head1[62] = {
0x42,0x4D,0x3E,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x00,0x00,0x28,0x00,
0x00,0x00,0xC0,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x00,0x00,
0x00,0x00,0x00,0x03,0x00,0x00,0xC4,0x0E,0x00,0x00,0xC4,0x0E,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0x00
};
/* 192*64 pxcel */
unsigned char Head2[62] = {
0x42,0x4D,0x3E,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x00,0x00,0x28,0x00,
0x00,0x00,0xC0,0x00,0x00,0x00,0x40,0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x00,0x00,
0x00,0x00,0x00,0x06,0x00,0x00,0xC4,0x0E,0x00,0x00,0xC4,0x0E,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0x00
};
/* mono wpbg */
#define BMP_PAL_OFF		58	/* pbgʒu */
unsigned char Pmono[4] = { 0x8F,0xBF,0xBF,0x00 };
